(function ($) {
    "use strict";

    /* ============================================= */
    /* ==== GOOGLE MAP ==== */

    function initmap() {

        //////////////////////////////////////google maps ////////////////////////////////////////////////////

        var $googleMap = $(".ct-googleMap");


        if (($googleMap.length > 0) && (typeof google === 'object' && typeof google.maps === 'object')) {

            // 100% Height -----------------------------------------------
            if ($googleMap.attr("data-height") == "100%") {
                $googleMap.css("height", $deviceheight + "px");
            }

            $googleMap.each(function () {
                var atcenter = "";
                var $this = $(this);
                var location = $this.data("location");
                var zoom = $this.data("zoom");
                var $drag = true;
                var lat = $this.data("latitude");
                var long = $this.data("longitude");

                if (device.mobile() || device.tablet() || ($devicewidth < 768)) {
                    $drag = false;
                }
                else {
                    $drag = true;
                }
                var offset = -30;

                if (validatedata($this.data("offset"))) {
                    offset = $this.data("offset");
                }

                if (validatedata(location)) {
                    $this.gmap3({
                        marker: {
                            //latLng: [40.616439, -74.035540],
                            address: location, options: {
                                //visible: false
                                icon: new google.maps.MarkerImage($googleMap.attr("data-marker"))
                            }, callback: function (marker) {
                                atcenter = marker.getPosition();
                            }
                        }, map: {
                            options: {
                                //maxZoom:11,
                                zoom: zoom,
                                styles: [{
                                    "featureType": "all",
                                    "elementType": "labels.text.fill",
                                    "stylers": [{"saturation": 36}, {"color": "#000000"}, {"lightness": 40}]
                                }, {
                                    "featureType": "all",
                                    "elementType": "labels.text.stroke",
                                    "stylers": [{"visibility": "on"}, {"color": "#000000"}, {"lightness": 16}]
                                }, {
                                    "featureType": "all",
                                    "elementType": "labels.icon",
                                    "stylers": [{"visibility": "off"}]
                                }, {
                                    "featureType": "administrative",
                                    "elementType": "geometry.fill",
                                    "stylers": [{"color": "#000000"}, {"lightness": 20}]
                                }, {
                                    "featureType": "administrative",
                                    "elementType": "geometry.stroke",
                                    "stylers": [{"color": "#000000"}, {"lightness": 17}, {"weight": 1.2}]
                                }, {
                                    "featureType": "landscape",
                                    "elementType": "geometry",
                                    "stylers": [{"color": "#000000"}, {"lightness": 20}]
                                }, {
                                    "featureType": "poi",
                                    "elementType": "geometry",
                                    "stylers": [{"color": "#000000"}, {"lightness": 21}]
                                }, {
                                    "featureType": "road.highway",
                                    "elementType": "geometry.fill",
                                    "stylers": [{"color": "#000000"}, {"lightness": 17}]
                                }, {
                                    "featureType": "road.highway",
                                    "elementType": "geometry.stroke",
                                    "stylers": [{"color": "#000000"}, {"lightness": 29}, {"weight": 0.2}]
                                }, {
                                    "featureType": "road.arterial",
                                    "elementType": "geometry",
                                    "stylers": [{"color": "#000000"}, {"lightness": 18}]
                                }, {
                                    "featureType": "road.local",
                                    "elementType": "geometry",
                                    "stylers": [{"color": "#000000"}, {"lightness": 16}]
                                }, {
                                    "featureType": "transit",
                                    "elementType": "geometry",
                                    "stylers": [{"color": "#000000"}, {"lightness": 19}]
                                }, {
                                    "featureType": "water",
                                    "elementType": "geometry",
                                    "stylers": [{"color": "#000000"}, {"lightness": 17}]
                                }],

                                mapTypeId: google.maps.MapTypeId.ROADMAP, // ('ROADMAP', 'SATELLITE', 'HYBRID','TERRAIN');
                                scrollwheel: false,
                                disableDoubleClickZoom: false,
                                draggable: $drag, //disableDefaultUI: true,
                                mapTypeControlOptions: {
                                    //mapTypeIds: [google.maps.MapTypeId.ROADMAP, google.maps.MapTypeId.HYBRID],
                                    //style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,
                                    //position: google.maps.ControlPosition.RIGHT_CENTER
                                    mapTypeIds: []
                                }
                            }, events: {
                                idle: function () {
                                    if (!$this.data('idle')) {
                                        $this.gmap3('get').panBy(0, offset);
                                        $this.data('idle', true);
                                    }
                                }
                            }
                        }, overlay: {
                            address: location, options: {
                                offset: {
                                    y: -100, x: -25
                                }

                            }
                        }
                        //},"autofit"
                    });

                    // center on resize
                    google.maps.event.addDomListener(window, "resize", function () {
                        //var userLocation = new google.maps.LatLng(53.8018,-1.553);
                        setTimeout(function () {
                            $this.gmap3('get').setCenter(atcenter);
                            $this.gmap3('get').panBy(0, offset);
                        }, 400);

                    });

                    // set height
                    $this.css("min-height", $this.data("height") + "px");
                } else {
                    if (validatedata(lat)) {


                        $this.gmap3({
                            marker: {
                                latLng: [lat, long],
                                options: {
                                    //visible: false
                                    icon: new google.maps.MarkerImage($googleMap.attr("data-marker"))
                                }, callback: function (marker) {
                                    atcenter = marker.getPosition();
                                }
                            }, map: {
                                options: {
                                    //maxZoom:11,
                                    zoom: zoom,
                                    styles: [{
                                        "featureType": "all",
                                        "elementType": "labels.text.fill",
                                        "stylers": [{"saturation": 36}, {"color": "#000000"}, {"lightness": 40}]
                                    }, {
                                        "featureType": "all",
                                        "elementType": "labels.text.stroke",
                                        "stylers": [{"visibility": "on"}, {"color": "#000000"}, {"lightness": 16}]
                                    }, {
                                        "featureType": "all",
                                        "elementType": "labels.icon",
                                        "stylers": [{"visibility": "off"}]
                                    }, {
                                        "featureType": "administrative",
                                        "elementType": "geometry.fill",
                                        "stylers": [{"color": "#000000"}, {"lightness": 20}]
                                    }, {
                                        "featureType": "administrative",
                                        "elementType": "geometry.stroke",
                                        "stylers": [{"color": "#000000"}, {"lightness": 17}, {"weight": 1.2}]
                                    }, {
                                        "featureType": "landscape",
                                        "elementType": "geometry",
                                        "stylers": [{"color": "#000000"}, {"lightness": 20}]
                                    }, {
                                        "featureType": "poi",
                                        "elementType": "geometry",
                                        "stylers": [{"color": "#000000"}, {"lightness": 21}]
                                    }, {
                                        "featureType": "road.highway",
                                        "elementType": "geometry.fill",
                                        "stylers": [{"color": "#000000"}, {"lightness": 17}]
                                    }, {
                                        "featureType": "road.highway",
                                        "elementType": "geometry.stroke",
                                        "stylers": [{"color": "#000000"}, {"lightness": 29}, {"weight": 0.2}]
                                    }, {
                                        "featureType": "road.arterial",
                                        "elementType": "geometry",
                                        "stylers": [{"color": "#000000"}, {"lightness": 18}]
                                    }, {
                                        "featureType": "road.local",
                                        "elementType": "geometry",
                                        "stylers": [{"color": "#000000"}, {"lightness": 16}]
                                    }, {
                                        "featureType": "transit",
                                        "elementType": "geometry",
                                        "stylers": [{"color": "#000000"}, {"lightness": 19}]
                                    }, {
                                        "featureType": "water",
                                        "elementType": "geometry",
                                        "stylers": [{"color": "#000000"}, {"lightness": 17}]
                                    }],

                                    mapTypeId: google.maps.MapTypeId.ROADMAP, // ('ROADMAP', 'SATELLITE', 'HYBRID','TERRAIN');
                                    scrollwheel: false,
                                    disableDoubleClickZoom: false,
                                    draggable: $drag, //disableDefaultUI: true,
                                    mapTypeControlOptions: {
                                        //mapTypeIds: [google.maps.MapTypeId.ROADMAP, google.maps.MapTypeId.HYBRID],
                                        //style: google.maps.MapTypeControlStyle.HORIZONTAL_BAR,
                                        //position: google.maps.ControlPosition.RIGHT_CENTER
                                        mapTypeIds: []
                                    }
                                }, events: {
                                    idle: function () {
                                        if (!$this.data('idle')) {
                                            $this.gmap3('get').panBy(0, offset);
                                            $this.data('idle', true);
                                        }
                                    }
                                }
                            }, overlay: {
                                latLng: [lat, long]
                                , options: {
                                    offset: {
                                        y: -100, x: -25
                                    }

                                }
                            }
                            //},"autofit"
                        });

                        // center on resize
                        google.maps.event.addDomListener(window, "resize", function () {
                            //var userLocation = new google.maps.LatLng(53.8018,-1.553);
                            setTimeout(function () {
                                $this.gmap3('get').setCenter(atcenter);
                                $this.gmap3('get').panBy(0, offset);
                            }, 400);

                        });

                        // set height
                        $this.css("min-height", $this.data("height") + "px");


                    }
                }

                if ($this.parent().parent().hasClass('hidemap')) {
                    $this.parent().animate({height: '0px'}, 500);
                }

            })
        }

    }

    initmap();
})(jQuery);