<?php
if (ct_get_option('activities_index_show_pagination')) {
    $postsPerPage = ct_get_option('activities_items_per_page', 10);
} else {
    $postsPerPage = -1;
}


$terms = ct_menu_get_terms(); ?>

<?php if ($terms): ?>
    <section class="ct-frame ct-frame--white">

        <?php
        /**
         * @param $price
         * @return string
         */
        function ct_get_price_with_currency($price)
        {
            $currency = ct_get_context_option('menu_product_index_currency', '');
            $currencyPos = ct_get_context_option('menu_index_currency_pos', 'left');

            if (!$currency) {
                return $price;
            } else {
                switch ($currencyPos) {
                    case 'right':
                        return $price . $currency;
                    case 'right_space':
                    default:
                        return $price . ' ' . $currency;
                    case 'left':
                        return $currency . $price;
                    case 'left_space':
                        return $currency . ' ' . $price;;
                }
            }
        }


        ?>



        <?php foreach ($terms as $term): ?>

            <?php
            global $post;
            $postsOrderby = ct_get_context_option('menu_index_items_order_by', 'title');
            $postsOrder = ct_get_context_option('menu_index_items_order', 'ASC');

            $paged = (get_query_var('paged')) ? get_query_var('paged') : 0;
            $args = array(
                'post_type' => 'ct_menu',
                'posts_per_page' => -1,
                'paged' => $paged,
                'orderby' => $post->menu_order,
                'order' => $postsOrder,
                'tax_query' => array(array(
                    'taxonomy' => 'ct_menu_category',
                    'field' => 'id',
                    'terms' => $term->term_id,
                    'hide_empty' => true,
                )
                ));
            if ($postsOrderby == 'price') {
                $args['orderby'] = 'meta_value_num';
                $args['meta_key'] = 'ct_price';
            } else if ( $postsOrderby == 'id' ) {
	            $args['orderby'] = 'ID';
            } else if ( $postsOrderby == 'slug' ) {
	            $args['orderby'] = 'name';
            } else if ( ! empty( $postsOrderby ) ) {
	            $args['orderby'] = $postsOrderby;
            }
            $posts = query_posts($args);

	        /**
	         * Sort posts by menu_order
	         * edit: only if $post->menu_order is set! otherwise causes random order when == matches. see usort docs
	         */
	        if ( ! empty( $post->menu_order ) ) {
		        usort( $posts, function ( $a, $b ) {
			        return $a->menu_order == $b->menu_order ? 0
                        : ( $a->menu_order < $b->menu_order ? - 1 : 1 );
		        } );
	        }
            ?>


            <?php if (have_posts()) : ?>

                <?php $pattern = ct_get_context_option('general_content_pattern', '13');?>

                <section class="ct-foodBox">
                    <div class="ct-imageBox ct-u-marginTop5 section section_1" id="<?php echo esc_attr($term->slug) ?>">
                        <?php echo ct_get_image(ct_get_term_image($term->term_id, 'img_url'), $term->name) ?>
                    </div>
                    <h3 class="text-center text-uppercase ct-u-font1 ct-fw-600"><?php echo esc_html($term->name) ?></h3>
                    <p class="text-center"><?php echo esc_html($term->description) ?></p>
                    <hr <?php echo ct_esc_attrs(
                        array(
                            array('attr' => 'data-bg', 'val' => ct_get_context_option('menu_index_top_divider'), 'url' => true),
                            array('attr' => 'data-bgrepeat', 'val' => ct_get_context_option('menu_index_top_divider_repeat', 'no-repeat')),
                            array('attr' => 'class', 'val' => 'hr-custom ct-js-background')
                        )); ?>>
                    <ul>

                        <?php

                        $postCount = 0;

                        ?>
                        <?php foreach($posts as $post): ?>

                            <?php
                            $custom = get_post_custom(get_the_ID());
                            $price = isset($custom["ct_price"][0]) ? $custom["ct_price"][0] : "";
                            ?>

                            <li class="ct-foodMenu">
                                <div class="ct-dottedBg"></div>
                                <label class="ct-u-font2 ptn<?php echo (int)$pattern;?>"><?php the_title() ?></label><span
                                    class="ct-u-font1 ptn<?php echo (int)$pattern;?>"><?php echo ct_get_price_with_currency($price) ?></span>

                                <div class="clearfix"></div>
                                <div class="ct-u-foodIngredients"><?php echo $post->post_content?></div>
                            </li>

                        <?php endforeach; ?>
                        <?php wp_reset_postdata() ?>
                        <!-- / menu-items-list -->
                    </ul>
                    <div class="ct-hrContainer ct-u-paddingTop15 ct-u-paddingBottom10">
                        <hr <?php echo ct_esc_attrs(
                            array(
                                array('attr' => 'data-bg', 'val' => ct_get_context_option('menu_index_bottom_divider'), 'url' => true),
                                array('attr' => 'data-bgrepeat', 'val' => ct_get_context_option('menu_index_bottom_divider_repeat')),
                                array('attr' => 'class', 'val' => 'hr-custom ct-js-background')
                            )); ?>>
                    </div>
                </section>


            <?php else: ?>
                <article>
                    <h4 class="no-result-found">
                        <?php _e('No menu items results found', 'ct_theme'); ?>
                    </h4>
                </article>
            <?php endif; ?>

        <?php endforeach ?>
    </section>

<?php else: ?>
    <article>
        <h4 class="no-result-found">
            <?php _e('No menu categories results found. Please setup menu categories first.', 'ct_theme'); ?>
        </h4>
    </article>
<?php endif; ?>
