<?php if (ct_is_woocommerce_active()): ?>
    <?php global $woocommerce; ?>


    <nav class="ct-topBar-navigation pull-left">
        <ul class="list-unstyled list-inline">
            <?php if (is_user_logged_in()) { ?>
                <li><a href="<?php echo get_permalink(get_option('woocommerce_myaccount_page_id')); ?>"
                       title="<?php _e('My Account', 'ct_theme'); ?>"><?php _e('My Account', 'ct_theme'); ?></a>
                </li>

                <?php

                if (sizeof($woocommerce->cart->cart_contents) > 0) { ?>
                    <li><a href="<?php echo esc_url(wc_get_checkout_url()) ?>"
                           title="<?php _e('Checkout','ct_theme') ?>"><?php _e('Checkout','ct_theme') ?></a></li>
                <?php } ?>

                <?php
                if (ct_is_location_contains_menu('shop_top_navigation')) {
                    ct_wp_nav_menu(
                        array(
                            'items_wrap' => '<ul id="%1$s" class="%2$s">%3$s</ul>',
                            'theme_location' => 'shop_top_navigation',
                            'menu_class' => 'shop_top_navigation',
                            'menu_id' => 'shop_top_nav'
                        )
                    );
                }
                ?>
                <li>
                    <a href="<?php echo esc_url(wp_logout_url()) ?>"><?php _e('Log Out', 'ct_theme') ?> </a>
                </li>
                <?php
            } else {
                ?>
                <li><a href="#" data-toggle="modal" data-target="#loginform"
                       title="<?php _e('Login / Register', 'ct_theme'); ?>"><?php _e('Login / Register', 'ct_theme'); ?></a>
                </li>
            <?php } ?>
        </ul>


    </nav>


    <div class="ct-sideBar-basket">
        <a href="#"><img src="<?php echo CT_THEME_ASSETS ?>/images/basket.png"
                         alt="Cart Icon"> <?php echo ct_get_context_option('shop_basket_label', 'my basket') ?>
            <span
                class="ct-topBar-basket-quantity"><?php echo sizeof($woocommerce->cart->cart_contents) > 0 ? '' : ct_get_context_option('shop_basket_label_empty', '(empty)') ?></span></a>

        <div class="ct-topBar-basketContainer">

            <?php if (ct_is_woocommerce_active()) { ?>
                <?php if (version_compare(WOOCOMMERCE_VERSION, "2.0.0") >= 0) {
                    the_widget('Custom_WooCommerce_Widget_Cart', 'title=');
                } else {
                    the_widget('WooCommerce_Widget_Cart', 'title=');
                } ?>
            <?php } ?>


        </div>

    </div>


    <div class="clearfix"></div>

<?php endif ?>