<?php
global $wp_query;
global $post;
$paged = (get_query_var('paged')) ? get_query_var('paged') : 1;

if (isset($_GET['cols'])) {
    switch ($_GET['cols']) {
        default:
        case 4:
            $colClass = 'ct-gallery--col4';
            break;
        case 5:
            $colClass = 'ct-gallery--col5';
            break;
    }
} else {
    if (ct_get_context_option('gallery_masonry_cols', 4) == 4) {
        $colClass = 'ct-gallery--col4';
    } else {
        $colClass = 'ct-gallery--col5';
    }
}


function ct_get_alt()
{
    $thumbnail = get_post(get_post_thumbnail_id());
    return get_post_meta($thumbnail->ID, '_wp_attachment_image_alt', true);
}

?>



<?php if (have_posts()) : ?>
    <section class="ct-gallery <?php echo sanitize_html_class($colClass)?> ct-gallery--withSpacing ct-js-popupGallery">
        <?php while (have_posts()) : the_post(); ?>
            <div class="ct-gallery-item ct-gallery-item--masonry hidden">
                <div class="ct-gallery-itemInner">
                    <?php echo ct_get_image_link(
                        array(
                            'img_src' => ct_get_feature_image_src(get_the_ID(), 'gallery_thumb'),
                            'img_alt' => ct_get_alt(),
                            'img_class' => 'ct-galleryShaddow',
                            'link_url' => ct_get_feature_image_src(get_the_ID(), 'full'),
                            'link_class' => 'ct-js-popup',
                        )) ?>
                </div>
            </div>
        <?php endwhile; ?>
    </section>

    <?php get_template_part('templates/portfolio/content-portfolio', 'pagination'); ?>



<?php else: ?>
    <article>
        <h4 class="no-result-found">
            <?php _e('No search results found', 'ct_theme'); ?>
        </h4>
    </article>
    <?php
endif;
?>



