<?php

/**
 * Config for customizer
 * @author alex
 */
class ctAdvancedCustomizerConfig
{

    /**
     * Hook to events
     */

    public function __construct()
    {

        add_filter('ct_customizer_mapper.configure', array($this, 'configure'));
        add_filter('ct_customizer.fapath', array($this, 'faPath'),1000);
        add_filter('ct_customizer_brand_config', array($this, 'customizerBrand'));
	    add_filter('ct_customizer_google_fonts',array($this,'importFonts'));

    }

	public function importFonts( $fonts ) {

    	array_push( $fonts, 'navbar-family', 'font-family1', 'font-family2', 'font-family3' );
    	return $fonts;
    }

    public function customizerBrand($config){
        $config['logoSrc'] = CT_THEME_SETTINGS_MAIN_DIR_URI . '/img/tp-logo.png';
        $config['docsSrc'] = CT_THEME_DIR_URI . '/docs/documentation.pdf';
        $config['docsString'] =  'Documentation';
        return $config;
    }

    public function faPath($path)
    {
        return '/fonts/font-awesome-4.2.0/fonts';
    }





    /**
     * @param ctControlsMapper $mapper
     */

    public function configure($mapper)
    {

        $mapper
            ->panel(__('Charlotte - style', 'ct_theme'))
            ->section(__('Colors and backgrounds setup', 'ct_theme'))
            ->add('@motive-light', __('Motive Light', 'ct_theme'), 'color')
            ->add('@motive', __('Motive', 'ct_theme'), 'color')
            ->add('@motive-dark', __('Motive dark', 'ct_theme'), 'color')
            ->add('@motive-darker', __('Motive darker', 'ct_theme'), 'color')
            ->add('@navbar-color', __('Navbar color', 'ct_theme'), 'color')
            ->add('@navbar-linkColor', __('Navbar link color', 'ct_theme'), 'color')
            ->add('@navbar-linkColorHover', __('Navbar link hover', 'ct_theme'), 'color')
            ->add('@navbar-linkColor', __('Navbar link color', 'ct_theme'), 'color')
            ->add( '@font-family1', __( 'First font family', 'ct_theme' ), 'font' )
            ->add( '@font-family2', __( 'Second font family', 'ct_theme' ), 'font' )
            ->add( '@font-family3', __( 'Third font family', 'ct_theme' ), 'font' )
            ->add( '@navbar-family', __( 'Base font navbar', 'ct_theme' ), 'font' )
            ->add( '@navbar-fontSize',
                __( 'Size', 'ct_theme' ),
                'numberselect',
                array( 'min' => 12, 'max' => 26, 'suffix' => 'px', 'step' => 2 ) )
            ->option('general_content_pattern', __('Select content pattern', 'ct_theme'), 'select',
                array('choices' => array(
                    'none' => __('none', "ct_theme"),
                    '1' => 'silver diagonals',
                    '2' => 'decorative diamonds',
                    '3' => '3D silver',
                    '4' => 'silver hexagons',
                    '5' => 'light carpet',
                    '6' => 'gray carpet',
                    '7' => 'diagonal diamonds',
                    '8' => 'silver',
                    '9' => 'gray wood',
                    '10' => 'beech wood',
                    '11' => 'light walnut wood',
                    '12' => 'natural beech wood',
                    '13' => 'bricks',
                    'default' => '')))
            ->panel(__('General', 'ct_theme'))
            ->section(__('Main', 'ct_theme'))
            ->option('general_logo_standard', __('Logo standard', 'ct_theme'), 'image', array())
            ->option('general_logo_mobile', __('Logo mobile', 'ct_theme'), 'image', array())
            ->option('general_login_logo', __('Login logo', 'ct_theme'), 'image', array())
            ->option('general_favicon', __('Favicon', 'ct_theme'), 'image', array())
            ->option('general_apple_touch_icon', __('Apple touch icon', 'ct_theme'), 'image', array())
            ->option('general_map_template_location', __('Map template location', 'ct_theme'), 'text', array())
            ->option('general_map_template_lat', __('Map template latitude', 'ct_theme'), 'text', array())
            ->option('general_map_template_lon', __('Map template longitude', 'ct_theme'), 'text', array())
            ->option('navbar_search', __('Search icon in navbar', 'ct_theme'), 'show',
                array('default' => '0'))
            ->option('navbar_search', __('Search icon in navbar', 'ct_theme'), 'show',
                array('default' => '0'))
            /*404 sidebar settings*/
            ->option('404_bg_img', __('Page 404 sidebar background image', 'ct_theme'), 'image', array())
            ->option('404_bg_img_repeat', __('Page 404 sidebar background style', 'ct_theme'), 'select',
                array('choices' => array(
                    '' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat',))
            ->option('404_sidebar_bg_animated', __('Page 404 sidebar animated background', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('yes', 'ct_theme'),
                    'ct-u-hideAnimateBg' => __('no', 'ct_theme'),
                ), 'default' => 'ct-u-hideAnimateBg',))
            /*404 sidebar settings end*/

            ->panel(__('Footer configuration', 'ct_theme'))
            ->panel(__('Pages', 'ct_theme'))
            ->section(__('Page sidebar options', 'ct_theme'))
            ->option('pages_header_sidebar_block', __('Select sidebar block', 'ct_theme'), 'posts', array('default' => '1', 'post_type'=>'ct_sidebar_block'))
            /*page sidebar settings*/
            ->option('pages_sidebar_bg_img', __('Page sidebar background image', 'ct_theme'), 'image', array())
            ->option('pages_sidebar_bg_repeat', __('Page sidebar background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat',))
            ->option('pages_sidebar_bg_animated', __('Page sidebar animated background', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('yes', 'ct_theme'),
                    'ct-u-hideAnimateBg' => __('no', 'ct_theme'),
                ), 'default' => 'ct-u-hideAnimateBg',))
            /*page sidebar settings end*/


            ->section(__('Header', 'ct_theme'))
            ////page header media settings start////



            ->option('pages_header_image', __('Header Image', 'ct_theme'), 'image', array())
            ->option('pages_header_image_mobile', __('Header Image mobile', 'ct_theme'), 'image', array())
            ->panel(__('Main navbar', 'ct_theme'))
            ->section(__('Main Navbar', 'ct_theme'))
            ->section(__('Style', 'ct_theme'))


            ->option('navbar_bg_img', __('Navbar background image', 'ct_theme'), 'image', array())
            ->option('navbar_hr1_bg_img', __('Top divider background', 'ct_theme'), 'image', array())
            ->option('navbar_hr2_bg_img', __('Bottom divider background', 'ct_theme'), 'image', array())
            ->option('navbar_hr1_bg_repeat', __('Top divider background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat',))
            ->option('navbar_hr2_bg_repeat', __('Bottom divider background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat', 'description' => 'Bottom divider background style.'))
            ->option('navbar_sidebar_show', __('Bottom sidebar', 'ct_theme'), 'select',
                array('choices' => array(
                    'show' => __('show', 'ct_theme'),
                    'hide' => __('hide', 'ct_theme'),
                ), 'default' => 'show', 'description' => 'Bottom widgets area'))
            ->panel(__('Posts', 'ct_theme'))
            ->section(__('Blog Sidebar options', 'ct_theme'))
            /*blog sidebar settings*/
            ->option('posts_index_sidebar_title_block_s', __('Show blog title block', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_sidebar_title_block_s', __('Show blog single title block', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_index_widget_area', __('Show sidebar widgets on blog index', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_widget_area', __('Show sidebar widgets on blog single', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_index_sidebar_bg_img', __('Blog index sidebar background image', 'ct_theme'), 'image', array())
            ->option('posts_index_sidebar_bg_repeat', __('Blog index sidebar background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat',))
            ->option('posts_single_sidebar_bg_img', __('Blog single sidebar background image', 'ct_theme'), 'image', array())
            ->option('posts_single_sidebar_bg_repeat', __('Blog single sidebar background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat',))
            ->option('posts_index_sidebar_bg_animated', __('Blog index sidebar animated background', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('yes', 'ct_theme'),
                    'ct-u-hideAnimateBg' => __('no', 'ct_theme'),
                ), 'default' => 'ct-u-hideAnimateBg',))
            ->option('posts_single_sidebar_bg_animated', __('Blog single sidebar animated background', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('yes', 'ct_theme'),
                    'ct-u-hideAnimateBg' => __('no', 'ct_theme'),
                ), 'default' => 'ct-u-hideAnimateBg',))
            /*page sidebar settings end*/

            ->section(__('Index', 'ct_theme'))
            ->option('posts_index_meta_separataor', __('Blog index meta separator', 'ct_theme'), 'text', array('default' => '&#9830;'))
            ->option('posts_index_title_row', __('Blog title', 'ct_theme'), 'text',
                array('default' => 'Blog',
                    'description' => ''))
            ->option('posts_index_show_title_row', __('Show posts index page title row', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_index_header_show_title_box', __('Show posts index page title text', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_index_more_label', __('Post detail button label', 'ct_theme'), 'text',
                array('default' => 'Read More',
                    'description' => ''))
            ->option('posts_index_pagination_prev', __('Pagination prev label', 'ct_theme'), 'text',
                array('default' => __('Previous page', 'ct_theme'),
                    'description' => ''))
            ->option('posts_index_pagination_next', __('Pagination next label', 'ct_theme'), 'text',
                array('default' => __('Next page', 'ct_theme'),
                    'description' => ''))
            ->option('posts_index_show_meta', __('Show meta', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            /*->option('posts_index_by_label', __('By label', 'ct_theme'), 'text',
                array('default' => 'By',
                    'description' => ''))*/
            ->option('posts_index_tags_label', __('Tags label', 'ct_theme'), 'text',
                array('default' => 'Tags:',
                    'description' => ''))
            ->option('posts_index_show_date', __('Date', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_index_show_media', __('Show featured media on blog index', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_index_show_title', __('Title / quote author', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_index_show_comments_link', __('Comments count', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_index_excerpt', __('Post text', 'ct_theme'), 'select',
                array('choices' => array(
                    'post_excerpt' => __('Show Excerpt', 'ct_theme'),
                    'post_full' => __('Show Full Text', 'ct_theme'),
                    'post_none' => __('No Text', 'ct_theme'),
                ),
                    'default' => 'post_excerpt',
                    'description' => ''))
            ->option('posts_index_show_author', __('Author link', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_index_show_more', __('Show read more button ?', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->section(__('Single', 'ct_theme'))
            ->option('posts_single_show_meta', __('Date', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_meta_separataor', __('Blog single meta separator', 'ct_theme'), 'text', array('default' => '&#9830;'))
            ->option('posts_single_show_tags', __('Tags', 'ct_theme'), 'show',
                array('default' => '0',
                    'description' => ''))
            ->option('posts_single_show_categories', __('Categories', 'ct_theme'), 'show',
                array('default' => '0',
                    'description' => ''))
            ->option('posts_single_show_title_row', __('Show posts single page title row', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_title_row', __('Post single page title', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('posts_single_show_date', __('Date', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_media', __('Show featured media on single post', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_post_title', __('Title / quote author', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_content', __('Content', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_author', __('Author link', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_comments', __('Comments', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_comment_form', __('Comment form', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_tags', __('Tag cloud', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_categories', __('Categories', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_author_box', __('Show author box', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_show_pagination', __('Pagination', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('posts_single_tags_label', __('Tags label', 'ct_theme'), 'text',
                array('default' => 'Tags:',
                    'description' => ''))
            ->option('posts_single_prev_label', __('Previous post label', 'ct_theme'), 'text',
                array('default' => 'Previous Post',
                    'description' => ''))
            ->option('posts_single_next_label', __('Next post label', 'ct_theme'), 'text',
                array('default' => 'Next Post',
                    'description' => ''))
            ->option('posts_single_by_label', __('By label', 'ct_theme'), 'text',
                array('default' => 'By',
                    'description' => ''))
            ->option('posts_single_comment_reply_label', __('Comment reply label', 'ct_theme'), 'text',
                array('default' => 'reply',
                    'description' => ''))
            ->option('posts_single_comment_form_leave_label', __('Leave a comment label', 'ct_theme'), 'text',
                array('default' => 'Leave a comment',
                    'description' => ''))
            ->option('posts_single_comment_form_submit', __('Comment Form submit label', 'ct_theme'), 'text',
                array('default' => 'Send message',
                    'description' => ''))
            ->option('posts_single_comment_placeholder_name', __('Comment Form name placeholder', 'ct_theme'), 'text',
                array('default' => 'Name',
                    'description' => ''))
            ->option('posts_single_comment_placeholder_email', __('Comment Form email placeholder', 'ct_theme'), 'text',
                array('default' => 'Email',
                    'description' => ''))
            ->option('posts_single_comment_placeholder_message', __('Comment Form message placeholder', 'ct_theme'), 'text',
                array('default' => 'Your message',
                    'description' => ''))
            ->option('posts_single_bottom_divider_bg', __('Bottom divider', 'ct_theme'), 'image', array())
            ->option('posts_single_bottom_divider_repeat', __('Bottom divider background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'ct_none',))
            ->option('posts_single_comments_top_divider_bg', __('Comments top divider', 'ct_theme'), 'image', array())
            ->option('posts_single_comments_top_divider_repeat', __('Comments top divider background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'ct_none',))
            ->option('posts_single_comments_bottom_divider_bg', __('Comments bottom divider', 'ct_theme'), 'image', array())
            ->option('posts_single_comments_bottom_divider_repeat', __('Comments bottom divider background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'ct_none',))
            ->option('posts_single_comment_form_divider_bg', __('Comment Form divider', 'ct_theme'), 'image', array())
            ->option('posts_single_comment_form_divider_repeat', __('Comment Form divider background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'ct_none',))
            ->panel(__('Socials', 'ct_theme'))
            ->section(__('Socials', 'ct_theme'))
            ->option('page_header_show_socials', __('Show socials box', 'ct_theme'), 'show',
                array('default' => '0',
                    'description' => ''))
            ->option('pages_header_socials_square', __('Select header socials style', 'ct_theme'), 'select',
                array('choices' => array(
                    "no" => __("Standard", "ct_theme"),
                    "yes" => __("Square", "ct_theme"),
                ),
                    'default' => 'no',
                    'description' => __('only available for the following icons:<br>xing, twitter, tumblr, pinterest, linkedin, google, github, facebook, bitbucket', 'ct_theme')))
            ->option('bitbucket', __('Bitbucket username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('dribbble', __('Dribbble username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('dropbox', __('Dropbox username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('email', __('Email', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('facebook', __('Facebook username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('flickr', __('Flickr username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('foursquare', __('Foursquare ID', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('github', __('Github username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('gittip', __('Gittip username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('google', __('Google plus username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('instagram', __('Instagram username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('linkedin', __('Linkedin username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('pinterest', __('Pinterest username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('renren', __('Renren ID', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('rss', __('RSS', 'ct_theme'), 'show',
                array('default' => '0',
                    'description' => ''))
            ->option('skype', __('Skype username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('stack_exchange', __('Stack Exchange ID', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('stack_overflow', __('Stack Overflow username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('tumblr', __('Tumblr username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('twitter', __('Twitter username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('vimeo', __('Vimeo username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('vkontakte', __('VKontakte username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('weibo', __('Weibo username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('xing', __('Xing username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('youtube', __('Youtube username', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->panel(__('Shop', 'ct_theme'))
            ->section(__('WooCommerce', 'ct_theme'))
            ////woocommerce index header media settings start////
            /*shop sidebar settings*/
            ->section(__('Shop Sidebar options', 'ct_theme'))
            ->option('product_index_sidebar_title_block_s', __('Show shop index title block', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('product_single_sidebar_title_block_s', __('Show shop single title block', 'ct_theme'), 'show',
                array('default' => '0',
                    'description' => ''))
            ->option('product_index_widget_area', __('Show sidebar widgets on shop index', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('product_single_widget_area', __('Show sidebar widgets on shop single', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('product_index_sidebar_block', __('Select title block for shop index', 'ct_theme'), 'posts', array('default' => '1', 'post_type' => 'ct_sidebar_block'))
            ->option('product_single_sidebar_block', __('Select title block for shop single', 'ct_theme'), 'posts', array('default' => '1', 'post_type' => 'ct_sidebar_block'))
            ->option('product_index_sidebar_bg_img', __('Shop index sidebar background image', 'ct_theme'), 'image', array())
            ->option('product_index_sidebar_bg_repeat', __('Shop index sidebar background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat',))
            ->option('product_single_sidebar_bg_img', __('Shop single sidebar background image', 'ct_theme'), 'image', array())
            ->option('product_single_sidebar_bg_repeat', __('Shop single sidebar background style', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat',))
            ->option('product_index_sidebar_bg_animated', __('Shop index sidebar animated background', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('yes', 'ct_theme'),
                    'ct-u-hideAnimateBg' => __('no', 'ct_theme'),
                ), 'default' => 'ct-u-hideAnimateBg',))
            ->option('product_single_sidebar_bg_animated', __('Shop single sidebar animated background', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('yes', 'ct_theme'),
                    'ct-u-hideAnimateBg' => __('no', 'ct_theme'),
                ), 'default' => 'ct-u-hideAnimateBg',))
            //sidebar settings END
            ->section(__('Shop index options', 'ct_theme'))
            ->option('shop_product_single_show_share', __('Show share icons?', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('shop_basket_label', __('Top navbar Basket label', 'ct_theme'), 'text',
                array('default' => 'My basket',
                ))
            ->option('shop_basket_label_empty', __('Top navbar Basket empty label', 'ct_theme'), 'text',
                array('default' => 'EMPTY',
                ))
            ->section(__('Shop single product options', 'ct_theme'))
            //header options
            ->option('product_single_title_row', __('Page title', 'ct_theme'), 'text',
                array('default' => 'Shop',
                    'description' => ''))
            ->panel(__('Restaurant Menu', 'ct_theme'))
            ->section(__('Sidebar', 'ct_theme'))
            /*blog sidebar settings*/
            ->option('menu_sidebar_title_block_s', __('Show Menu Card title block', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => ''))
            ->option('menu_sidebar_title_block', __('Select title block for menu sidebar', 'ct_theme'), 'posts', array('default' => '1', 'post_type' => 'ct_sidebar_block'))
            ->option('menu_navbar_divider_bg_img', __('Sidebar bottom divider background', 'ct_theme'), 'image', array())
            ->option('menu_navbar_divider_bg_repeat', __('Sidebar bottom divider background repeat', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat',))
            ->section(__('Menu index', 'ct_theme'))
            ->option('menu_index_top_divider', __('Menu index top divider background', 'ct_theme'), 'image', array())
            ->option('menu_index_bottom_divider', __('Menu index bottom divider background', 'ct_theme'), 'image', array())
            ->option('menu_index_top_divider_repeat', __('Menu index top divider repeat', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat', 'description' => 'Bottom divider background style.'))
            ->option('ct_menu_index_bottom_divider_repeat', __('Menu index bottom divider repeat', 'ct_theme'), 'select',
                array('choices' => array(
                    'ct_none' => __('repeat', 'ct_theme'),
                    'no-repeat' => __('no repeat', 'ct_theme'),
                ), 'default' => 'no-repeat', 'description' => 'Bottom divider background style.'))
            ->option('menu_product_index_currency', __('Currency', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => ''))
            ->option('menu_index_currency_pos', __('Menu index currency position', 'ct_theme'), 'select',
                array('choices' => array(
                    'left' => __('left', 'ct_theme'),
                    'left_space' => __('left space', 'ct_theme'),
                    'right' => __('right', 'ct_theme'),
                    'right_space' => __('right space', 'ct_theme'),
                ), 'default' => 'left', 'description' => 'Select currency position.'))
            ->section(__('Filtering', 'ct_theme'))
            ->option('menu_index_cat_order_by', __('Categories order by', 'ct_theme'), 'select',
                array('choices' => array(
                    'name' => __('name', 'ct_theme'),
                    'count' => __('count', 'ct_theme'),
                    'slug' => __('slug', 'ct_theme'),
                    'id' => __('id', 'ct_theme'),
                ), 'default' => 'name'))
            ->option('menu_index_cat_order', __('Categories order', 'ct_theme'), 'select',
                array('choices' => array(
                    'ASC' => __('ascending', 'ct_theme'),
                    'DESC' => __('descending', 'ct_theme'),
                ), 'default' => 'ASC', 'description' => ''))
            ->option('menu_index_cat_custom_order', __('Categories custom order', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => 'separate category slugs by commas'))
            ->option('menu_index_items_order_by', __('Food items order by', 'ct_theme'), 'select',
                array('choices' => array(
                    'title' => __('title', 'ct_theme'),
                    'price' => __('price', 'ct_theme'),
                    'date' => __('date', 'ct_theme'),
                    'modified' => __('order by last modified date', 'ct_theme'),
                    'rand' => __('random', 'ct_theme'),
                    'slug' => __('slug', 'ct_theme'),
                    'id' => __('id', 'ct_theme'),
                ), 'default' => 'title'))
            ->option('menu_index_items_order', __('Food items order', 'ct_theme'), 'select',
                array('choices' => array(
                    'ASC' => __('ascending', 'ct_theme'),
                    'DESC' => __('descending', 'ct_theme'),
                ), 'default' => 'ASC', 'description' => ''))

            ///////GALLERY General///////
            ->panel(__('Gallery setup', 'ct_theme'))
            ->section(__('General options', 'ct_theme'))
            ->option('portfolio_type', __('Select portfolio type', 'ct_theme'), 'select',
                array('choices' => array(
                    'masonry' => __('masonry', 'ct_theme'),
                    'infinite' => __('infinite scroll', 'ct_theme'),
                ), 'default' => 'masonry'))
            ->option('portfolio_index_slug', __('Custom index slug', 'ct_theme'), 'text',
                array('default' => __('gallery', 'ct_theme'),
                    'description' => ''))
            ->option('portfolio_index_limit', __('Limit', 'ct_theme'), 'text',
                array('default' => '10',
                    'description' => ''))
            ///////GALLERY Masonry///////
            ->section(__('Masonry type options', 'ct_theme'))
            ->option('gallery_masonry_cols', __('Columns', 'ct_theme'), 'select',
                array('choices' => array(
                    '4' => __('4', 'ct_theme'),
                    '5' => __('5', 'ct_theme'),
                ), 'default' => '4'))
            ->option('gallery_index_pagination_prev', __('Pagination prev label', 'ct_theme'), 'text',
                array('default' => __('Previous page', 'ct_theme'),
                    'description' => ''))
            ->option('gallery_index_pagination_next', __('Pagination next label', 'ct_theme'), 'text',
                array('default' => __('Next page', 'ct_theme'),
                    'description' => ''))
            /********************************GALLERY FILTERS***************************************************/
            ->section(__('Filters', 'ct_theme'))
            ->option('portfolio_index_show_cats', __('Show categories ?', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => 'Description'))

            ->option('portfolio_index_show_cats_all', __('Show All button', 'ct_theme'), 'show',
                array('default' => '1',
                    'description' => 'Description'))
            ->option('portfolio_index_cats_all_label', __('Categories All button label', 'ct_theme'), 'text',
                array('default' => 'All',
                    'description' => 'Description'))
            ->option('portfolio_index_cats_order_by', __('Categories buttons order by', 'ct_theme'), 'select',
                array('choices' => array(
                    'name' => __('name', 'ct_theme'),
                    'count' => __('count', 'ct_theme'),
                    'slug' => __('slug', 'ct_theme'),
                    'id' => __('id', 'ct_theme'),
                ), 'default' => 'name','description' => 'Description' ))
            ->option('portfolio_index_cats_order', __('Categories buttons order', 'ct_theme'), 'select',
                array('choices' => array(
                    'ASC' => __('ascending', 'ct_theme'),
                    'DESC' => __('descending', 'ct_theme'),
                ), 'default' => 'ASC', 'description' => ''))
            ->option('portfolio_index_cats_custom_order', __('Categories custom order', 'ct_theme'), 'text',
                array('default' => '',
                    'description' => 'separate category slugs by commas'))
            ->option('portfolio_index_items_order_by', __('Gallery items order by', 'ct_theme'), 'select',
                array('choices' => array(
                    'title' => __('title', 'ct_theme'),
                    'date' => __('date', 'ct_theme'),
                    'modified' => __('order by last modified date', 'ct_theme'),
                    'rand' => __('random', 'ct_theme'),
                    'slug' => __('slug', 'ct_theme'),
                    'id' => __('id', 'ct_theme'),
                ), 'default' => 'title'))
            ->option('portfolio_index_items_order', __('Gallery items order', 'ct_theme'), 'select',
                array('choices' => array(
                    'ASC' => __('ascending', 'ct_theme'),
                    'DESC' => __('descending', 'ct_theme'),
                ), 'default' => 'ASC', 'description' => ''))
            /********************************END GALLERY FILTERS END***************************************************/
            ->section(__('Infinite type options', 'ct_theme'))
            ///////GALLERY infinite///////
            ->option('gallery_infinite_cols', __('Columns', 'ct_theme'), 'select',
                array('choices' => array(
                    '4' => __('4', 'ct_theme'),
                    '5' => __('5', 'ct_theme'),
                ), 'default' => 'title'))
            ->option('gallery_infinite_random', __('Random sizes', 'ct_theme'), 'select',
                array('choices' => array(
                    'yes' => __('yes', 'ct_theme'),
                    'no' => __('no', 'ct_theme'),
                ), 'default' => 'yes'));
        return $mapper;
    }
}

new ctAdvancedCustomizerConfig();