<?php

/**
 * Class ctForwardPlugin
 */
class ctForwardPlugin
{


    /**
     * @var int
     */
    public $qoID;



    /**
     *
     */
    public function __construct()
    {

        $this->qoID = get_queried_object_id();
    }

    /**
     * @param $queried_object_id
     * @return bool|string
     */
    protected function getPageTemplateSlug($queried_object_id)
    {
        return get_post_meta($queried_object_id, '_wp_page_template', true);
    }

    /**
     * @param $path
     */
    protected function loadTemplate($path)
    {
        get_template_part($path);
    }

    /**
     * @param $path
     */
    protected function isBlog()
    {
        if (get_option('page_for_posts') == get_queried_object_id() && !is_single()) {
            return true;
        }
        return false;
    }

    /**
     * @return bool
     */
    public function isWoocommerce()
    {
        if (function_exists('is_woocommerce')) {
            global $post;

            if (!$post && !is_woocommerce())return false;

            if (!ct_is_woocommerce_active()){
                return false;
            }

            if (is_woocommerce()) {
                return true;
            }


            if (is_shop()) {
                return true;
            }
           if (($post->ID == get_option('woocommerce_cart_page_id'))) {
                return true;
            }

            if (is_checkout()) {
                return true;
            }

            if (($post->ID == get_option('woocommerce_myaccount_page_id'))) {
                return true;
            }
            if (($post->ID == get_option('woocommerce_pay_page_id'))) {
                return true;
            }
            if (($post->ID == get_option('woocommerce_thanks_page_id'))) {
                return true;
            }
            if (($post->ID == get_option('woocommerce_edit_address_page_id'))) {
                return true;
            }
            if (($post->ID == get_option('woocommerce_view_order_page_id'))) {
                return true;
            }
            if (($post->ID == get_option('woocommerce_terms_page_id'))) {
                return true;
            }
        } else {
            return false;
        }
    }


    /**
     * @param array $forwardMap
     */
    public function getTemplatePartIf($forwardMap = array())
    {
        $currentPageTemplate = $this->getPageTemplateSlug($this->qoID);
        global $post;
        foreach ($forwardMap as $k => $v) {

            $obj = get_queried_object();
            if (apply_filters('ct.getTemplatePartIf.force_disable', false, $obj)){
                return;
            }

            if ('__404' === $k && (is_404())) {
                $this->loadTemplate($v);
                return;
            }

            if (is_404()) {
                return;
            }



            if ('__author' === $k && (is_author())) {
                $this->loadTemplate($v);
                return;
            }

            if ('__category' === $k && (is_category())) {
                $this->loadTemplate($v);
                return;
            }


            if ('__tag' === $k && (is_tag())) {
                $this->loadTemplate($v);
                return;
            }


            if ($currentPageTemplate == $k && !$this->isBlog() &&  !$this->isWoocommerce() && !is_author() && !is_category() && !is_tag() && !is_search()) {
                $this->loadTemplate($v);
                return;
            }


            if ('__blog' === $k) {
                if ($this->isBlog() && !$this->isWoocommerce()) {
                    $this->loadTemplate($v);
                    return;
                }
            }


            if ('__blog_single' === $k) {
                if (is_single() && $post->post_type=='post') {
                    $this->loadTemplate($v);
                    return;
                }
            }


            if ('__search' === $k && (is_search())) {
                $this->loadTemplate($v);
                return;
            }

            if ('__woocommerce' === $k && !is_search()) {
                if (class_exists(('WooCommerce'))) {
                    if ($this->isWoocommerce()) {
                        $this->loadTemplate($v);
                        return '';
                    }
                    //return $this->isWoocommerce();
                }
            }

            if ('__archive' === $k) {
                if (is_archive() && !$this->isWoocommerce() && !is_author() && !is_category() && !is_tag() && !is_search()) {
                    $this->loadTemplate($v);
                    return;
                }
            }
        }
        $this->loadTemplate('templates/side-title-row/side-title-row-content');
        return;


    }
}


if (!function_exists('ct_get_template_if')) {
    /**
     * @param array $data
     */
    function ct_get_template_if($data = array())
    {
        $obj = new  ctForwardPlugin();
        $obj->getTemplatePartIf($data);
    }
}
