<?php

add_filter('ct.utility_class.compatible_shortcodes', 'ct_get_compatible_shortcodes');
add_filter('ct.utility_class.attr', 'ct_set_utility_class_attr',10,2);


/**
 * @return mixed|void
 */
function ct_get_compatible_shortcodes($shortcodes)
{

    $shortcodes = array(
        'format',
        'header',
        'icon',
        'image_box'
    );
    return $shortcodes;
}


/**
 * @return mixed|void
 */
function ct_set_utility_class_attr($attrs, $group)
{

    $attrs = array();
    $attrs['ct_u_size_14'] = array(
        'label' => __("Font Size 14", 'ct_theme'),
        'type' => 'checkbox',
        'default' => '',
        'value' => 'ct-u-size14',
        'group' => $group,
        'help' => __('Make the text 20px', 'ct_theme'),
        'supported_by' => array('header'),
        'not_supported_by' => array('section', 'icon', 'section_header'),
    );

    $attrs['ct_u_color_motive'] = array(
        'label' => __("Motive color", 'ct_theme'),
        'type' => 'checkbox',
        'default' => '',
        'value' => 'ct-u-colorMotive',
        'group' => $group,
        'help' => __('Apply motive color to element', 'ct_theme'),
        'supported_by' => array('header'),
        'not_supported_by' => array('section', 'icon', 'section_header'),
    );


    $attrs['ct_u_underline_hover'] = array(
        'label' => __("Underline hover", 'ct_theme'),
        'type' => 'checkbox',
        'default' => '',
        'value' => 'ct-u-underline',
        'group' => $group,
        'help' => __('Underline text on mouse over', 'ct_theme'),
        'supported_by' => array(),
        'not_supported_by' => array('section', 'header', 'icon', 'section_header'),
    );

    $attrs['ct_u_text_transform'] = array(
        'label' => __("Text transform", 'ct_theme'),
        'type' => 'select',
        'default' => '',
        'choices' => array(
            '' => __('none', 'ct_thene'),
            'text-uppercase' => __('uppercase', 'ct_theme'),
            'text-lowercase' => __('lowercase', 'ct_theme'),
        ),
        'group' => $group,
        'help' => __('Select text transformation type', 'ct_theme'),
        'supported_by' => array(),
        'not_supported_by' => array('section', 'icon', 'header'),
    );


    $attrs['ct_u_header'] = array(
        'label' => __('Header', 'ct_theme'),
        'default' => '',
        'group' => $group,
        'type' => 'select',
        'choices' =>
            array(
                "" => __("none", "ct_theme"),
                "h1" => __("1", "ct_theme"),
                "h2" => __("2", "ct_theme"),
                "h3" => __("3", "ct_theme"),
                "h4" => __("4", "ct_theme"),
                "h5" => __("5", "ct_theme"),
                "h6" => __("6", "ct_theme"),
            ),
        'help' => sprintf(__('Display text as header', 'ct_theme')),
        'supported_by' => array('format'),
        'not_supported_by' => array(),
    );

    $attrs['ct_u_padding'] = array(
        'label' => __('Padding', 'ct_theme'),
        'default' => '',
        'group' => $group,
        'type' => 'select',
        'choices' =>
            array(
                "" => __("none", "ct_theme"),
                "ct-u-paddingBoth5" => __("both 5", "ct_theme"),
                "ct-u-paddingTop5" => __("top 5", "ct_theme"),
                "ct-u-paddingBottom5" => __("bottom 5", "ct_theme"),
                "ct-u-paddingBoth10" => __("both 10", "ct_theme"),
                "ct-u-paddingTop10" => __("top 10", "ct_theme"),
                "ct-u-paddingBottom10" => __("bottom 10", "ct_theme"),
                "ct-u-paddingBoth20" => __("both 20", "ct_theme"),
                "ct-u-paddingTop20" => __("top 20", "ct_theme"),
                "ct-u-paddingBottom20" => __("bottom 20", "ct_theme"),
                "ct-u-paddingBoth30" => __("both 30", "ct_theme"),
                "ct-u-paddingTop30" => __("top 30", "ct_theme"),
                "ct-u-paddingBottom30" => __("bottom 30", "ct_theme"),
                "ct-u-paddingBoth40" => __("both 40", "ct_theme"),
                "ct-u-paddingTop40" => __("top 40", "ct_theme"),
                "ct-u-paddingBottom40" => __("bottom 40", "ct_theme"),
                "ct-u-paddingBoth50" => __("both 50", "ct_theme"),
                "ct-u-paddingTop50" => __("top 50", "ct_theme"),
                "ct-u-paddingBottom50" => __("bottom 50", "ct_theme"),
                "ct-u-paddingBoth60" => __("both 60", "ct_theme"),
                "ct-u-paddingTop60" => __("top 60", "ct_theme"),
                "ct-u-paddingBottom60" => __("bottom 60", "ct_theme"),
                "ct-u-paddingBoth70" => __("both 70", "ct_theme"),
                "ct-u-paddingTop70" => __("top 70", "ct_theme"),
                "ct-u-paddingBottom70" => __("bottom 70", "ct_theme"),
                "ct-u-paddingBoth80" => __("both 80", "ct_theme"),
                "ct-u-paddingTop80" => __("top 80", "ct_theme"),
                "ct-u-paddingBottom80" => __("bottom 80", "ct_theme"),
                "ct-u-paddingBoth90" => __("both 90", "ct_theme"),
                "ct-u-paddingTop90" => __("top 90", "ct_theme"),
                "ct-u-paddingBottom90" => __("bottom 90", "ct_theme"),
                "ct-u-paddingBoth100" => __("both 100", "ct_theme"),
                "ct-u-paddingTop100" => __("top 100", "ct_theme"),
                "ct-u-paddingBottom100" => __("bottom 100", "ct_theme"),
                "ct-u-paddingBoth150" => __("both 150", "ct_theme"),
                "ct-u-paddingTop150" => __("top 150", "ct_theme"),
                "ct-u-paddingBottom150" => __("bottom 150", "ct_theme"),
            ),
        'help' => sprintf(__('Add paddings to the element', 'ct_theme')),
        'supported_by' => array(),
        'not_supported_by' => array('icon'),
    );

    $attrs['ct_u_margin'] = array(
        'label' => __('Margin', 'ct_theme'),
        'default' => '',
        'group' => $group,
        'type' => 'select',
        'choices' =>
            array(
                "" => __("none", "ct_theme"),
                "ct-u-marginBoth5" => __("both 5", "ct_theme"),
                "ct-u-marginTop5" => __("top 5", "ct_theme"),
                "ct-u-marginBottom5" => __("bottom 5", "ct_theme"),
                "ct-u-marginBoth10" => __("both 10", "ct_theme"),
                "ct-u-marginTop10" => __("top 10", "ct_theme"),
                "ct-u-marginBottom10" => __("bottom 10", "ct_theme"),
                "ct-u-marginBoth20" => __("both 20", "ct_theme"),
                "ct-u-marginTop20" => __("top 20", "ct_theme"),
                "ct-u-marginBottom20" => __("bottom 20", "ct_theme"),
                "ct-u-marginBoth30" => __("both 30", "ct_theme"),
                "ct-u-marginTop30" => __("top 30", "ct_theme"),
                "ct-u-marginBottom30" => __("bottom 30", "ct_theme"),
                "ct-u-marginBoth40" => __("both 40", "ct_theme"),
                "ct-u-marginTop40" => __("top 40", "ct_theme"),
                "ct-u-marginBottom40" => __("bottom 40", "ct_theme"),
                "ct-u-paddingBoth50" => __("both 50", "ct_theme"),
                "ct-u-marginTop50" => __("top 50", "ct_theme"),
                "ct-u-marginBottom50" => __("bottom50", "ct_theme"),
                "ct-u-marginTop60" => __("top 60", "ct_theme"),
                "ct-u-marginBottom60" => __("bottom 60", "ct_theme"),
                "ct-u-marginBoth70" => __("both 70", "ct_theme"),
                "ct-u-marginTop70" => __("top 70", "ct_theme"),
                "ct-u-marginBottom70" => __("bottom 70", "ct_theme"),
                "ct-u-marginBoth80" => __("both 80", "ct_theme"),
                "ct-u-marginTop80" => __("top 80", "ct_theme"),
                "ct-u-marginBottom80" => __("bottom 80", "ct_theme"),
                "ct-u-marginBoth90" => __("both 90", "ct_theme"),
                "ct-u-marginTop90" => __("top 90", "ct_theme"),
                "ct-u-marginBottom90" => __("bottom 90", "ct_theme"),
                "ct-u-marginBoth100" => __("both 100", "ct_theme"),
                "ct-u-marginTop100" => __("top 100", "ct_theme"),
                "ct-u-marginBottom100" => __("bottom 100", "ct_theme"),
                "ct-u-marginBoth150" => __("both 150", "ct_theme"),
                "ct-u-marginTop150" => __("top 150", "ct_theme"),
                "ct-u-marginBottom150" => __("bottom 150", "ct_theme"),
            ),
        'help' => sprintf(__('Add margins to the element', 'ct_theme')),
        'supported_by' => array(),
        'not_supported_by' => array('icon'),
    );

    $attrs['ct_u_font_weight'] = array(
        'label' => __('Font weight', 'ct_theme'),
        'default' => '',
        'group' => $group,
        'type' => 'select',
        'choices' =>
            array(
                "" => __("None", "ct_theme"),
                "ct-fw-300" => __("weight 300", "ct_theme"),
                "ct-fw-400" => __("weight 400", "ct_theme"),
                "ct-fw-500" => __("weight 500", "ct_theme"),
                "ct-fw-600" => __("weight 600", "ct_theme"),
                "ct-fw-700" => __("weight 700", "ct_theme"),
                "ct-fw-800" => __("weight 800", "ct_theme"),
            ),
        'help' => sprintf(__('Choose font weight for the text', 'ct_theme')),
        'supported_by' => array(),
        'not_supported_by' => array('section', 'icon', 'section_header'),
    );



    return $attrs;
}


