<?php

/**
 * Pricelist shortcode
 */
class ctContentBoxItemShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface
{

    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Content box item';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'content_box_item';
    }

    /**
     * Parent shortcode name
     * @return null
     */

    public function getParentShortcodeName()
    {
        return 'content_box';
    }

    /**
     * Returns shortcode type
     * @return mixed|string
     */

    public function getShortcodeType()
    {
        return self::TYPE_SHORTCODE_ENCLOSING;
    }


    /**
     * Handles shortcode
     *
     * @param $atts
     * @param null $content
     *
     * @return string
     */

    public function handle($atts, $content = null)
    {
        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));
        $dividerRel = $this->buildRelatedShortcode('ct_divider', $atts, 'divider_rel');


        return '<!--Content Box Item Start-->
                    <h4 class="ct-u-font1 text-uppercase ct-u-colorMotive ct-smallTitle">
                        ' . $title . '
                    </h4>
                    <h4 class="ct-u-font2 text-uppercase ct-u-colorWhite">
                        ' . $subtitle . '
                    </h4>
                    <p>
                        ' . $desc . '
                    </p>
                    ' . $dividerRel.'
                <!--Content Box Item End-->';
                }


    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {
        $items = array(
            'title' => array('label' => __('Title', 'ct_theme'), 'default' => '', 'type' => 'input'),
            'subtitle' => array('label' => __('Subtitle', 'ct_theme'), 'default' => '', 'type' => 'input'),
            'desc' => array('label' => __('Description', 'ct_theme'), 'default' => '', 'type' => 'input'),
        );

        $items = $this->mergeShortcodeAttributes($items, 'ct_divider', 'divider_rel', __('Divider', 'ct_theme'));
        return $items;

    }

    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
            'icon' => 'fa-picture-o',
        ));
    }
}

new ctContentBoxItemShortcode();



