<?php

/**
 * Pricelist shortcode
 */
class ctContentBoxShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface
{

    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Content box';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'content_box';
    }

    /**
     * Returns shortcode type
     * @return mixed|string
     */

    public function getShortcodeType()
    {
        return self::TYPE_SHORTCODE_ENCLOSING;
    }


    /**
     * Handles shortcode
     *
     * @param $atts
     * @param null $content
     *
     * @return string
     */

    public function handle($atts, $content = null)
    {
        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));


        $mainContainerAtts = array(
            'class' => array(
                $class,
                'ct-frame',
                'ct-frame--motive',
                'text-center'
            ),
        );


        return '<!--Content Box Start-->
                    <section' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>
                       '.do_shortcode($content).'
                    </section>
                <!--Content Box End-->';


    }


    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {
        $items = array(
            'class' => array('label' => __("Custom class", 'ct_theme'), 'default' => '', 'type' => 'input', 'help' => __('Adding custom class allows you to set diverse styles in css to the element. Type in name of class, which you defined in css. You can add as much classes as you like.', 'ct_theme')),
        );

        return $items;
    }


    public function getChildShortcodeInfo()
    {
        return array('name' => 'content_box_item', 'min' => 1, 'max' => 100, 'default_qty' => 3);
    }


    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
                'icon' => 'fa-picture-o',
                'container' => true
            )
        );
    }


}

new ctContentBoxShortcode();



//#28150
if(class_exists('WPBakeryShortCodesContainer')){
    class WPBakeryShortcode_content_box extends WPBakeryShortCodesContainer{}
}