<?php

/**
 * Pricelist shortcode
 */
class ctContactBoxItemShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface
{

    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Contact box item';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'contact_box_item';
    }

    /**
     * Parent shortcode name
     * @return null
     */

    public function getParentShortcodeName()
    {
        return 'contact_box';
    }

    /**
     * Returns shortcode type
     * @return mixed|string
     */

    public function getShortcodeType()
    {
        return self::TYPE_SHORTCODE_ENCLOSING;
    }


    /**
     * Handles shortcode
     *
     * @param $atts
     * @param null $content
     *
     * @return string
     */

    public function handle($atts, $content = null)
    {
        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));
        $dividerRel = $this->buildRelatedShortcode('ct_divider', $atts, 'divider_rel');
        $headerRel = $this->buildRelatedShortcode('header', $atts, 'header_rel');
        !isset($atts['divider_rel_default_type'])?$atts['divider_rel_default_type']='none':$atts['divider_rel_default_type'];
        if ($atts['divider_rel_default_type'] == 'none' && !isset($atts['divider_rel_bg_image'])){
            $dividerRel ='';
        }

        return $headerRel . '<!--Contact Box Item Start-->
                                <p class="ct-address ct-u-font2">'
                                    . $content .
                                '</p>'
                                . $dividerRel .
                            '<!--Contact Box Item End-->';
    }


    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {
        //merge from related HEADER->FORMAT1->CONTENT
        $items[$this->getParamNameFromNamespace('header', 'header_rel')] = array(
            'default' => '',
            'group' => '',
            'type' => 'textarea',
            'label' => __('Header', 'ct_theme'),
        );


        $items['content'] = array('label' => __('Content', 'ct_theme'), 'default' => '', 'type' => 'input');
        $items = $this->mergeShortcodeAttributes($items, 'header', 'header_rel', __('Header', 'ct_theme'));
        $items = $this->mergeShortcodeAttributes($items, 'ct_divider', 'divider_rel', __('Divider', 'ct_theme'));
        return $items;
    }

    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
            'icon' => 'fa-phone-square',
        ));
    }
}

new ctContactBoxItemShortcode();



