<?php

/**
 * Pricelist shortcode
 */
class ctContactBoxShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface
{

    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Contact box';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'contact_box';
    }

    /**
     * Returns shortcode type
     * @return mixed|string
     */

    public function getShortcodeType()
    {
        return self::TYPE_SHORTCODE_ENCLOSING;
    }


    /**
     * Handles shortcode
     *
     * @param $atts
     * @param null $content
     *
     * @return string
     */

    public function handle($atts, $content = null)
    {
        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));
        return do_shortcode('<!--Contact Box Start-->'
                                . $content .
                            '<!--Contact Box End-->');
    }


    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {
        $items = array(
            'class' => array('label' => __("Custom class", 'ct_theme'), 'default' => '', 'type' => false, 'help' => __('Adding custom class allows you to set diverse styles in css to the element. Type in name of class, which you defined in css. You can add as much classes as you like.', 'ct_theme')),
        );

        return $items;
    }


    public function getChildShortcodeInfo()
    {
        return array('name' => 'contact_box_item', 'min' => 1, 'max' => 100, 'default_qty' => 3);
    }


    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
                'icon' => 'fa-phone-square',
                'container' => true
            )
        );
    }
}

new ctContactBoxShortcode();



