<?php
require_once CT_THEME_LIB_DIR . '/shortcodes/socials/ctTwitterShortcodeBase.class.php';

/**
 * Twitter shortcode
 */
class ctTwitterShortcode extends ctTwitterShortcodeBase implements ctVisualComposerShortcodeInterface{


    /**
     * Handles shortcode
     * @param $atts
     * @param null $content
     * @return string
     */

    public function handle($atts, $content = null)
    {
        $attributes = shortcode_atts($this->extractShortcodeAttributes($atts), $atts);
        extract($attributes);

        $mainContainerAtts = array(
            'class' => array(
                'tweets'
            ),
            'id' => 'twitter-' . rand(100, 1000)
        );


        $html = '';
        $followLink = $this->getFollowLink($user);
        $tweets = $this->getTweets($attributes);

        $counter = 1;
        $class = ' tweet';

        if ($widgetmode == true) {

            $scrollBoxFormatterArgs = array(
                'main_container_height' => '300px',
                'icon_up_class' => 'fa fa-chevron-up',
                'icon_down_class' => 'fa fa-chevron-down',
                'ul_max_height' => '300px',
                'main_container_class' => 'with-scroll',
                'no_scroll' => false,
                'ul_class' => 'tweet_list slides',
                'before_list' => '<div class="tweets_display">',
                'after_list' => '</div>',
                'raw_content' => true
            );


            foreach ($tweets as $tweet) {
                $class .= $counter == 1 ? ' tweet_first' : '';
                $class .= $counter == 2 ? ' tweet_even' : ' tweet_odd';
                $html .= '<li style="list-style: none" class="tweetBox ' . $class . '">
                <p>
                        <a class="tweet_user" href="' . esc_url($followLink) . '">' . $tweet->user . '</a>
						<span class="tweet_text">' . $tweet->content . '</span>
						<span class="tweet_time">
							<a href="' . esc_url($followLink) . '" title="' . $tooltip . '">' . $this->ago($tweet->updated) . '</a>
						</span>
                </p>
	               </li>';

                $counter++;
                $counter = ($counter < 4) ? $counter : 1;
            }

        } else {
            foreach ($tweets as $tweet) {
                $html .= $counter == 1 ? '<ul class="tweet_list ">' : '';
                $class .= $counter == 1 ? ' tweet_first' : '';
                $class .= $counter == 2 ? ' tweet_even' : ' tweet_odd';
                $html .= '<li style="list-style: none" class="tweetBox ' . $class . '">

						<span class="tweet_text">
						<a href="' . esc_url($followLink) . '">' . $tweet->user . '</a>
							' . $tweet->content . '
						</span>
						<span class="tweet_time">

							<a href="' . $followLink . '">' . $this->ago($tweet->updated) . '</a>
						</span>
	               </li>';

                $html .= $counter == 3 ? '</ul>' : '';
                $counter++;
                $counter = ($counter < 4) ? $counter : 1;
            }
        }


        if ($counter != 1 && $widgetmode != true) {
            $html .= '</ul>';
        }

        if ($widgetmode == "true") {

            $headerShortcode = $header ? '[header class ="color-motive uppercase" level="4"]' . $header . '[/header]' : '';
        } else {
            $headerShortcode = $header ? '[header level="3"]' . $header . '[/header]' : '';
        }


        if ($button && $widgetmode == "false") {
            $followButton_shortcode = '[button type="primary" size="sm" icon="fa-twitter" link="' . $followLink . '"]' . $button . '[/button]';
        } else {
            $followButton_shortcode = '';
        }


        $twitter = $headerShortcode;
        $twitter .= '<div ' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>'
            . $html
            . $followButton_shortcode . '
 </div>
        ';
        return do_shortcode($twitter);
    }

    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {
        $args = array_merge(
            array(
                'widgetmode' => array('default' => 'false', 'type' => false),
                'header' => array('label' => __('header', 'ct_theme'), 'default' => __('Latest Tweets', 'ct_theme'), 'type' => 'input'),
                'tooltip' => array('label' => __('Tweet time tooltip text', 'ct_theme'), 'default' => __('view tweet on twitter', 'ct_theme'), 'type' => 'input'),
            ), parent::getAttributes());
        return $args;
    }

    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo() {
        return new ctVisualComposerInfo( $this, array(
	        'icon' => 'fa-twitter',
	        'description' => __( "Display your latest tweets", 'ct_theme')
	        ) );
    }
}

new ctTwitterShortcode();