<?php

/**
 * H. Paragraph shortcode
 */
class ctHighlightedParagraphShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface{


    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Highlighted Paragraph';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'highlighted_paragraph';
    }

    /**
     * Returns shortcode type
     * @return mixed|string
     */

    public function getShortcodeType()
    {
        return self::TYPE_SHORTCODE_ENCLOSING;
    }

    /**
     * Handles shortcode
     * @param $atts
     * @param null $content
     * @return string
     */

    public function handle($atts, $content = null)
    {
        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));

        $mainContainerAtts = array(
            'class' => array(
                'ct-blogItem',
                'ct-middleContent',
                $class
            )
        );

            return do_shortcode('<div ' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '><p>' . $content . '</p></div>');


    }


    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {
        return array(
           'content' => array('label' => __('Content', 'ct_theme'), 'default' => '', 'type' => "textarea"),
            'class' => array('label' => __('CSS class', 'ct_theme'), 'default' => '', 'type' => 'input'),
        );
    }

    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo() {
        return new ctVisualComposerInfo( $this, array(
	        'icon' => 'fa-list',
	        'description' => __( "Add text paragraph", 'ct_theme')
	        ) );
    }
}

new ctHighlightedParagraphShortcode();