<?php

/**
 * Title row shortcode
 */
class ctPageTitleShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface
{


    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Page Title';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'page_title';
    }

    /**
     *
     */

    public function enqueueScripts()
    {

    }


    /**
     * Handles shortcode
     *
     * @param $atts
     * @param null $content
     *
     * @return string
     */

    public function handle($atts, $content = null)
    {

        if (is_page_template('page-blank.php') || is_page_template('page-comingsoon.php')) {
            $header = $breadcrumbs = '';
        }else {
            $header = ct_get_title();
        }

        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));

        if (empty($header)) {
            return '';
        }


        $mainContainerAtts['class'] = array(
            ct_get_current_page_setting('font_style','', $atts),
            ct_get_current_page_setting('text_transform','', $atts),
            ct_get_current_page_setting('class','', $atts),
        );


        $html = '<h' .$level. $this->buildContainerAttributes($mainContainerAtts, $atts) . '>' . $header.'</h'.$level.'>';


        return $html;


    }


    /**
     * is template with sidebar?
     * @return bool
     */
    protected function isSidebar()
    {
        return is_page_template('page-custom.php') || is_page_template('page-custom-left.php');
    }

    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {
        return array(
            'level' => array(
                'label' => __('Header level (1-6)', 'ct_theme'),
                'default' => '2',
                'type' => 'select',
                'options' => array(
                    '1' => '1',
                    '2' => '2',
                    '3' => '3',
                    '4' => '4',
                    '5' => '5',
                    '6' => '6',
                )
            ),

            'font_style' => array(
                'label' => __('Font style', 'ct_theme'),
                'default' => 'ct-u-font-2',
                'type' => 'select',
                'options' => array(
                    'ct_none' => 'Raleway',
                    'ct-u-font1' => 'gravitas',
                    'ct-u-font2' => 'fjalla',
                )
            ),

            'text_transform' => array(
                'label' => __("Text transform", 'ct_theme'),
                'type' => 'select',
                'default' => 'text-uppercase',
                'choices' => array(
                    '' => __('none', 'ct_thene'),
                    'text-uppercase' => __('uppercase', 'ct_theme'),
                    'text-lowercase' => __('lowercase', 'ct_theme'),
                ),
            ),

            'class' => array('label' => __("Custom class", 'ct_theme'), 'default' => '', 'type' => 'input', 'help' => __('Adding custom class allows you to set diverse styles in css to the element. Type in name of class, which you defined in css. You can add as much classes as you like.', 'ct_theme')),
        );
    }

    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
            'icon' => 'fa-header',
            'container' => false,
            'description' => __( "Display title of current page", 'ct_theme')
        ));
    }


}

new ctPageTitleShortcode();



