<?php

/**
 * Contact shortcode
 */
class ctContactInfoShortcode extends ctShortcode
{


    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Contact Info';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'contact_info';
    }

    /**
     * Handles shortcode
     * @param $atts
     * @param null $content
     * @return string
     */

    public function handle($atts, $content = null)
    {
        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));

        $mainContainerAtts = array(
            'class' => array(
                'ct-contactInfo',
                'text-uppercase',
                $class,
            ),
        );

        return do_shortcode('
        <!--Contact Info Start-->
            <div' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>
            <h5 class="ct-u-colorMotive ct-u-font3">' . $title . '</h5>
            <p class="ct-u-font2">' . $content . '</p>
            </div>
        <!--Contact Info End-->
        ');
    }


    /**
     * Returns config
     *
     * @return null
     */
    public function getAttributes()
    {
        $items = array(
            'title' => array('label' => __('Title', 'ct_theme'), 'default' => __('GET IN TOUCH', 'ct_theme'), 'type' => 'input'),
            'content' => array('label' => __('Content', 'ct_theme'), 'default' => '', 'type' => "textarea"),
            'class' => array('label' => __("Custom class", 'ct_theme'), 'default' => '', 'type' => 'input', 'help' => __('Adding custom class allows you to set diverse styles in css to the element. Type in name of class, which you defined in css. You can add as much classes as you like.', 'ct_theme')),
        );
        return $items;
    }
}

new ctContactInfoShortcode();