<?php

/**
 * Big Slider Item shortcode
 */
class ctBigSliderHomeItemShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface
{

    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Big Slider Item';
    }

    /**
     * Parent shortcode name
     * @return null
     */
    public function getParentShortcodeName()
    {
        return 'ct_big_slider';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'ct_big_slider_item';
    }

    /**
     * Handles shortcode
     * @param $atts
     * @param null $content
     * @return string
     */
    public function handle($atts, $content = null)
    {
        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));

        $mainContainerAtts = array(
            'class' => array(
                'item',
                'ct-u-padding10',
                $class
            ),
        );
        $output =  '<div' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>'.$content.'</div>';
        return do_shortcode($output);
    }


    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {

        return array(
            'class' => array('label' => __("Custom class", 'ct_theme'), 'default' => '', 'type' => 'input', 'help' => __('Adding custom class allows you to set diverse styles in css to the element. Type in name of class, which you defined in css. You can add as much classes as you like.', 'ct_theme')),
        );
    }

    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
	        'icon' => 'fa-picture-o',
	        'container' => true,
	        'description' => __( "Add a child element of the slider", 'ct_theme')
	        ));
    }
}

new ctBigSliderHomeItemShortcode();

//#28150
if(class_exists('WPBakeryShortCodesContainer')){
    class WPBakeryShortcode_ct_big_slider_item extends WPBakeryShortCodesContainer{}
}