<?php

/**
 * Flex Slider shortcode
 * /**
 * Class ctSliderShortcode
 */
class ctBigSliderShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface
{


    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Big Slider';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'ct_big_slider';
    }

    /**
     *
     */
    public function enqueueScripts()
    {

        wp_register_script('owl.carousel.min.js', CT_THEME_ASSETS . '/plugins/owl/owl.carousel.min.js', array('jquery'), false, true);
        wp_enqueue_script('owl.carousel.min.js');

        wp_register_script('init.js', CT_THEME_ASSETS . '/plugins/owl/init.js', array('jquery'), false, true);
        wp_enqueue_script('init.js');

    }


    /**
     * Handles shortcode
     * @param $atts
     * @param null $content
     * @return string
     */

    public function handle($atts, $content = null)
    {
        $attributes = shortcode_atts($this->extractShortcodeAttributes($atts), $atts);
        extract($attributes);


        //modifiers
        $mainContainerAtts['class'] = array(
            'ct-js-owl',
        );

        $mainContainerAtts['data-animations'] = $animation == 'enable' ? true : false;
        $mainContainerAtts['data-height'] = '100%';
        $mainContainerAtts['data-snap-ignore'] = true;
        $mainContainerAtts['data-autoPlay'] = $autoplay;
        $mainContainerAtts['data-autoPlaySpeed'] = $autoplay_speed;

        return '<div' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>' . do_shortcode($content) . '</div>';
    }


    /**
     * Returns config
     * @return null
     *
     *
     */
    public function getAttributes()
    {


        $items['animation'] = array(
            'label' => __('Animation', 'ct_theme'),
            'default' => 'enable',
            'type' => 'select',
            'choices' =>
                array(
                    "enable" => __("enable", "ct_theme"),
                    "disable" => __("disable", "ct_theme"),
                ),
            'help' => __('Shows animation or not', 'ct_theme')
        );

        $items['autoplay'] = array(
            'label' => __('Autoplay', 'ct_theme'),
            'default' => 'false',
            'type' => 'select',
            'choices' =>
                array(
                    "false" => __("no", "ct_theme"),
                    "true" => __("yes", "ct_theme"),
                ),
            'help' => __('Slideshow', 'ct_theme')
        );

        $items['autoplay_speed'] = array('label' => __("Autoplay speed", 'ct_theme'), 'default' => '5000', 'type' => 'input', 'help' => __('Change to any integrer for example 5000 to play every 5 seconds.', 'ct_theme'));

        $items['class'] = array('label' => __("Custom class", 'ct_theme'), 'default' => '', 'type' => 'input', 'help' => __('Adding custom class allows you to set diverse styles in css to the element. Type in name of class, which you defined in css. You can add as much classes as you like.', 'ct_theme'));




        /*var ctautoplay = parseBoolean($this.attr("data-autoPlay"), false);
        if($this.attr("data-autoPlaySpeed") != null){
            ctautoplay = parseInt(validatedata($this.attr("data-autoPlaySpeed"), 5000));
        }*/

        return ($items);
    }

    public function getChildShortcodeInfo()
    {
        return array('name' => 'ct_big_slider_item', 'min' => 1, 'max' => 100, 'default_qty' => 3);
    }


    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
            'icon' => 'fa-picture-o',
            'container' => true,
            'description' => __("Add slider with custom content", 'ct_theme')
        ));
    }

}

new ctBigSliderShortcode();

//#28150
if(class_exists('WPBakeryShortCodesContainer')){
    class WPBakeryShortcode_ct_big_slider extends WPBakeryShortCodesContainer{}
}