<?php

/**
 * Flex Slider shortcode
 * /**
 * Class ctSliderShortcode
 */
class ctBlogGallerySliderShortcode extends ctShortcodeQueryable implements ctVisualComposerShortcodeInterface
{


    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Blog gallery Slider';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'ct_blog_gallery_slider';
    }

    /**
     *
     */
    public function enqueueScripts()
    {
        wp_register_script('owl.carousel.min.js', CT_THEME_ASSETS . '/plugins/owl/owl.carousel.min.js', array('jquery'), false, true);
        wp_enqueue_script('owl.carousel.min.js');

        wp_register_script('init.js', CT_THEME_ASSETS . '/plugins/owl/init.js', array('jquery'), false, true);
        wp_enqueue_script('init.js');
    }


    /**
     * Handles shortcode
     * @param $atts
     * @param null $content
     * @return string
     */

    public function handle($atts, $content = null)
    {

        $attributes = shortcode_atts($this->extractShortcodeAttributes($atts), $atts);
        extract($attributes);


        if ($post_slug === '') return '';

        $post = $this->getCollection($attributes, array('name' => $post_slug, 'limit' => 1));

        if (is_array($post)) {
            $p = $post[0];
            $post_id = $p->ID;
        } else {
            return '';
        }

        if (!ct_easy_galery_exist($post_id)) {
            return '';
        }

        $urls = ct_get_easy_gallery_Images($post_id);


        $mainContainerAtts = array(
            'data-items' => '1',
            'data-single' => 'false',
            'data-navigation' => 'true',
            'data-pagination' => 'false',
            'data-lgItems' => '1',
            'data-mdItems' => '1',
            'data-smItems' => '1'
        );

        $mainContainerAtts['class'] = array(
            'ct-js-owl',
            'ct-js-popupGallery',
            $class
        );

        $portfolios = $this->getCollection($attributes, array('post_type' => 'post'));
        if (empty($portfolios)) {
            return;
        }
        $output = '';
        foreach ($urls as $url) {
            $output .= '<div class="item ct-u-padding10">';
            $output .= ct_get_image($url, __('alt image', 'ct_theme'));
            $output .= '</div>';
        }


        return '<div' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>' . do_shortcode($output) . '</div>';

    }


    /**
     * Returns config
     * @return null
     *
     *
     */
    public function getAttributes()
    {

        $items['post_slug'] = array('label' => __("Post slug", 'ct_theme'), 'default' => '', 'type' => 'input', 'help' => __('', 'ct_theme'));
        $items['class'] = array('label' => __("Custom class", 'ct_theme'), 'default' => '', 'type' => 'input', 'help' => __('Adding custom class allows you to set diverse styles in css to the element. Type in name of class, which you defined in css. You can add as much classes as you like.', 'ct_theme'));


        return $this->getAttributesWithQuery($items);
    }


    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
            'icon' => 'fa-picture-o',
            'container' => true,
            'description' => __("Add slider with testimonials, gallery or custom images", 'ct_theme')
        ));
    }

}

new ctBlogGallerySliderShortcode();

//#28150
if(class_exists('WPBakeryShortCodesContainer')){
    class WPBakeryShortcode_ct_blog_gallery_slider extends WPBakeryShortCodesContainer{}
}