<?php

/**
 * Flex Slider shortcode
 * /**
 * Class ctSliderShortcode
 */
class ctPortfolioSliderShortcode extends ctShortcodeQueryable implements ctVisualComposerShortcodeInterface
{


    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'Portfolio Slider';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'portfolio_slider';
    }

    /**
     *
     */
    public function enqueueScripts()
    {
        wp_register_script('owl.carousel.min.js', CT_THEME_ASSETS . '/plugins/owl/owl.carousel.min.js', array('jquery'), false, true);
        wp_enqueue_script('owl.carousel.min.js');

        wp_register_script('init.js', CT_THEME_ASSETS . '/plugins/owl/init.js', array('jquery'), false, true);
        wp_enqueue_script('init.js');
    }


    /**
     * @param $id
     * @param $size
     * @return array
     */
    private function getAttachedImages($id, $size)
    {
        $urlArr = array();
        $imageUrl = '';
        $width = 270;
        $height = 160;
        $args = array(
            'post_type' => 'attachment',
            'numberposts' => -1,
            'post_status' => null,
            'post_parent' => $id
        );

        $attachments = get_posts($args);

        if ($attachments) {
            foreach ($attachments as $attach) {
                $image = wp_get_attachment_image_src($attach->ID, $size);
                $imageUrl = $image[0];
                $urlArr[] = $imageUrl;
            }
        }

        return $urlArr;
    }


    /**
     * Handles shortcode
     * @param $atts
     * @param null $content
     * @return string
     */

    public function handle($atts, $content = null)
    {
        $attributes = shortcode_atts($this->extractShortcodeAttributes($atts), $atts);
        extract($attributes);
        $id = ($id == '') ? 'slider' . rand(100, 1000) : $id;

        /*build slider items*/
        $items = '';

        $mainContainerAtts = array(
            'data-items' => '2',
            'data-single' => 'false',
            'data-navigation' => 'true',
            'data-pagination' => 'false',
            'data-lgItems' => '2',
            'data-mdItems' => '2',
            'data-smItems' => '1'
        );

        $mainContainerAtts['class'] = array(
            'ct-js-owl',
            'ct-js-popupGallery',
            $class
        );

        $portfolios = $this->getCollection($attributes, array('post_type' => 'portfolio'));
        if (empty($portfolios)){
            return;
        }
        $portfolios = array_chunk($portfolios, 2);
        $output = '';
        foreach ($portfolios as $chunk) {
            $p = $chunk[0];
            $output .= '<div class="item ct-u-padding10">';
            $output .= ct_get_image_link(
                array(
                    'img_src' => ct_get_feature_image_src($p->ID, 'ct_portfolio_slider_thumb'),
                    'img_alt' => 'Portfolio image',
                    'link_url' => ct_get_feature_image_src($p->ID, 'full'),
                    'link_class' => 'ct-js-popup ct-gallerySlider-image',
                    'link_attrs' => array(
                        array('attr' => 'title', 'val' => $p->post_title),
                    )
                ));

            if ( ! empty( $chunk[1] ) ) {
                $p = $chunk[1];

                $output .= ct_get_image_link(
                    array(
                        'img_src' => ct_get_feature_image_src($p->ID, 'ct_portfolio_slider_thumb'),
                        'img_alt' => 'Portfolio image',
                        'link_url' => ct_get_feature_image_src($p->ID, 'full'),
                        'link_class' => 'ct-js-popup ct-gallerySlider-image',
                        'link_attrs' => array(
                            array('attr' => 'title', 'val' => $p->post_title),
                        )
                    ));
            }
            $output .= '</div>';
        }

       return  '<div' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>' . do_shortcode($output) . '</div>';

    }


    /**
     * Returns config
     * @return null
     *
     *
     */
    public function getAttributes()
    {

        $items['class'] = array('label' => __("Custom class", 'ct_theme'), 'default' => '', 'type' => 'input', 'help' => __('Adding custom class allows you to set diverse styles in css to the element. Type in name of class, which you defined in css. You can add as much classes as you like.', 'ct_theme'));


        return $this->getAttributesWithQuery($items);
    }


    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
            'icon' => 'fa-picture-o',
            'container' => true,
            'description' => __("Add slider with testimonials, gallery or custom images", 'ct_theme')
        ));
    }

}

new ctPortfolioSliderShortcode();

//#28150
if(class_exists('WPBakeryShortCodesContainer')){
    class WPBakeryShortcode_portfolio_slider extends WPBakeryShortCodesContainer{}
}