<?php

/**
 * List item shortcode
 */
class ctListSimpleItemShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface
{


    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'List Simple Item';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'list_simple_item';
    }

    /**
     * Returns shortcode type
     * @return mixed|string
     */
    public function getShortcodeType()
    {
        return self::TYPE_SHORTCODE_ENCLOSING;
    }


    /**
     * Handles shortcode
     *
     * @param $atts
     * @param null $content
     *
     * @return string
     */
    public function handle($atts, $content = null)
    {
        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));


        $var1 = ctListSimpleShortcode::$type;


        if ($open_new_tab == 'yes') {
            $tab = 'target="_blank"';
        } else
            $tab = '';

        if ($content === '') {
            return '';
        }

        $mainContainerAtts = array(
            'class' => array(
                ct_get_current_page_setting('font_style', '', $atts),
                ),
        );



        if ($link == '') {
            return do_shortcode(' <li ' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>' . $content . '</li>');
        } else {
            return do_shortcode(' <li ' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '><a href="' . esc_url($link) . '" ' . $tab . '>' . $content . '</a></li>');
        }


    }

    /**
     * @return string
     */
    public function getParentShortcodeName()
    {
        return 'list_simple';
    }


    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {
        $items = array(

            'content' => array(
                'label' => __('Content', 'ct_theme'),
                'default' => '',
                'type' => "input"
            ),
            'link' => array(
                'label' => __('Link', 'ct_theme'),
                'default' => '',
                'type' => "input"
            ),


            'open_new_tab' => array('label' => __('Open on new tab', 'ct_theme'), 'default' => 'no', 'type' => 'select', 'choices' =>
                array(
                    'no' => __('no', 'ct_theme'),
                    'yes' => __('yes', 'ct_theme'),
                )),

            'font_style' => array(
                'label' => __('Font style', 'ct_theme'),
                'default' => 'ct-u-font-2',
                'type' => 'select',
                'options' => array(
                    'ct_none' => 'Raleway',
                    'ct-u-font1' => 'gravitas',
                    'ct-u-font2' => 'fjalla',
                )
            ),


        );
        return $items;
    }

    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
            'icon' => 'fa-list',
            'description' => __("Add single list item", 'ct_theme')
        ));
    }
}

new ctListSimpleItemShortcode();