<?php

/**
 * List shortcode
 */
class ctListSimpleShortcode extends ctShortcode implements ctVisualComposerShortcodeInterface
{


    /**
     * Returns name
     * @return string|void
     */
    public function getName()
    {
        return 'List Simple';
    }

    /**
     * Shortcode name
     * @return string
     */
    public function getShortcodeName()
    {
        return 'list_simple';
    }

    /**
     * Returns shortcode type
     * @return mixed|string
     */
    public function getShortcodeType()
    {
        return self::TYPE_SHORTCODE_ENCLOSING;
    }


    /**
     * Handles shortcode
     *
     * @param $atts
     * @param null $content
     *
     * @return string
     */

    public static $type;


    public function handle($atts, $content = null)
    {
        extract(shortcode_atts($this->extractShortcodeAttributes($atts), $atts));

        $mainContainerAtts = array(
            'class' => array(
                $large == 'yes'?'ct-u-size24':'',
                $text_transform!==''?$text_transform:'',
                $class,
                $type,
                $center == 'yes' ? 'text-center' : ''
            ),
        );



        switch ($type) {
            default:
            case '':
                self::$type = 'ordered';
                $html = '<ol' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>' . do_shortcode($content) . '</ol>';
                break;

            case 'ct-unorderedList':
                self::$type = 'ct-unorderedList';
                $html = '<ul' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>' . do_shortcode($content) . '</ul>';
                break;


            case 'list-unstyled':
                self::$type = 'no_bullets';
                $html = '<ul' . $this->buildContainerAttributes($mainContainerAtts, $atts) . '>' . do_shortcode($content) . '</ul>';
                break;
        }


        return do_shortcode( $html);
    }

    /**
     * Child shortcode info
     * @return array
     */

    public function getChildShortcodeInfo()
    {
        return array('name' => 'list_simple_item', 'min' => 1, 'max' => 20, 'default_qty' => 2);
    }

    /**
     * Returns config
     * @return null
     */
    public function getAttributes()
    {
        return array(
            'widgetmode' => array('default' => 'false', 'type' => false),
            'type' => array('label' => __('type', 'ct_theme'),
                'default' => 'ordered',
                'type' => 'select',
                'options' => array(
                    '' => __('ordered', 'ct_theme'),
                    'ct-unorderedList' => __('unordered', 'ct_theme'),
                    'list-unstyled' => __('no bullets', 'ct_theme'))),


            'center' => array(
                'label' => __("Center list", 'ct_theme'),
                'type' => 'select',
                'default' => 'no',
                'choices' => array(
                    'no' => __('no', 'ct_theme'),
                    'yes' => __('yes', 'ct_theme'),
                ),
            ),

            'large' => array(
                'label' => __("Large text", 'ct_theme'),
                'type' => 'select',
                'default' => 'no',
                'choices' => array(
                    'no' => __('no', 'ct_theme'),
                    'yes' => __('yes', 'ct_theme'),
                ),
            ),

            'text_transform' => array(
                'label' => __("Text transform", 'ct_theme'),
                'type' => 'select',
                'default' => 'text-uppercase',
                'choices' => array(
                    'none' => __('none', 'ct_thene'),
                    'text-uppercase' => __('uppercase', 'ct_theme'),
                    'text-lowercase' => __('lowercase', 'ct_theme'),
                ),
            ),

            'class' => array(
                'label' => __('Custom class', 'ct_theme'),
                'type' => 'input',
                'default' => '',
                'help' => "Set custom class to element"
            ),

        );
    }

    /**
     * Returns additional info about VC
     * @return ctVisualComposerInfo
     */
    public function getVisualComposerInfo()
    {
        return new ctVisualComposerInfo($this, array(
            'icon' => 'fa-list',
            'description' => __("Add list group", 'ct_theme')
        ));
    }
}

new ctListSimpleShortcode();

//#28150
if(class_exists('WPBakeryShortCodesContainer')){
    class WPBakeryShortcode_list_simple extends WPBakeryShortCodesContainer{}
}