<?php
/**
 * Plugin Name: createIT PostTypes Plugin for Charlotte
 * Plugin URI: http://createit.pl
 * Description: Custom post types required for the theme
 * Version: 1.3
 * Author: createIT
 * Author URI: http://createit.pl
 */


/**
 * Class ctPostTypes
 */
class ctCharlottePostTypes
{


    /**
     *
     */
    private function setupConstants()
    {

        define('PLUGIN_VERSION_CHARLOTTE', '1.0.0');

        if (!defined('CTPT_URL_CHARLOTTE'))
            define('CTPT_URL_CHARLOTTE', plugin_dir_url(__FILE__));

        if (!defined('CTPT_DIR_CHARLOTTE'))
            define('CTPT_DIR_CHARLOTTE', plugin_dir_path(__FILE__));


        if (!defined('CTPT_POST_TYPES_DIR_CHARLOTTE')) {
            define('CTPT_POST_TYPES_DIR_CHARLOTTE', CTPT_DIR_CHARLOTTE . '/includes/post-types');
        }

        if (!defined('CTPT_BASE_DIR_CHARLOTTE')) {
            define('CTPT_BASE_DIR_CHARLOTTE', CTPT_DIR_CHARLOTTE . 'includes/post-types-base');
        }

        if (!defined('CTPT_ASSETS_DIR_CHARLOTTE')) {
            define('CTPT_ASSETS_DIR_CHARLOTTE', CTPT_DIR_CHARLOTTE . '/includes/assets');
        }

        if (!defined('CTPT_ASSETS_URI_CHARLOTTE')) {
            define('CTPT_ASSETS_URI_CHARLOTTE', CTPT_URL_CHARLOTTE . '/includes/assets');
        }

    }


    /**
     *
     */
    public function __construct()
    {
        $this->setupConstants();
        require_once CTPT_BASE_DIR_CHARLOTTE . '/ctTypeBase.class.php';
        $this->loadFiles(CTPT_BASE_DIR_CHARLOTTE);
        $this->loadFiles(CTPT_POST_TYPES_DIR_CHARLOTTE);

    }


    /**
     * @param $path
     */
    public function loadFiles($path)
    {
        foreach (glob($path . '/*.php') as $filename) {
            include_once $filename;
        }
    }
}

new ctCharlottePostTypes();


