<?php
if (!class_exists('ctPageType')) {


    //require_once CT_THEME_LIB_DIR . '/types/ctPageTypeBase.class.php';

    /**
     * page type
     */
    class ctPageType extends ctPageTypeBase
    {

        /**
         * Adds meta box
         */

        public function addMetaBox()
        {
            parent::addMetaBox();
            add_meta_box("page-template-meta", __("Template settings", 'ct_theme'), array($this, "pageTemplateMeta"), "page", "normal", "low");
            add_meta_box("page-header-meta", __("Page side content settings", 'ct_theme'), array($this, "pageHeaderMeta"), "page", "normal", "high");
            //add_meta_box("page-gallery-meta", __("Gallery template settings", 'ct_theme'), array($this, "pageGalleryMeta"), "page", "normal", "high");
        }


        /**
         * page template settings
         */

        public function pageTemplateMeta()
        {
            global $post;
            $custom = get_post_custom($post->ID);
            $title = isset($custom["show_title_row"][0]) ? $custom["show_title_row"][0] : "";
            $pages_header_show_title_box = isset($custom["pages_header_show_title_box"][0]) ? $custom["pages_header_show_title_box"][0] : "";
            $bread = isset($custom["show_breadcrumbs"][0]) ? $custom["show_breadcrumbs"][0] : "";
            ?>

            <p>
                <label for="show_title_row"><?php _e('Show title row', 'ct_theme') ?>: </label>
                <select id="show_title_row" name="show_title_row">
                    <option
                        value="global" <?php echo selected('global', $title) ?>><?php _e("use global settings", 'ct_theme') ?></option>
                    <option
                        value="yes" <?php echo selected('yes', $title) ?>><?php _e("show title", 'ct_theme') ?></option>
                    <option
                        value="no" <?php echo selected('no', $title) ?>><?php _e("hide title", 'ct_theme') ?></option>
                </select>
            </p>
            <p class="howto"><?php _e("Show page title?", 'ct_theme') ?></p>


            <p>
                <label for="pages_header_show_title_box"><?php _e('Show title text', 'ct_theme') ?>: </label>
                <select id="pages_header_show_title_box" name="pages_header_show_title_box">
                    <option
                        value="global" <?php echo selected('global', $pages_header_show_title_box) ?>><?php _e("use global settings", 'ct_theme') ?></option>
                    <option
                        value="yes" <?php echo selected('yes', $pages_header_show_title_box) ?>><?php _e("show title text", 'ct_theme') ?></option>
                    <option
                        value="no" <?php echo selected('no', $pages_header_show_title_box) ?>><?php _e("hide title text", 'ct_theme') ?></option>
                </select>
            </p>
            <p class="howto"><?php _e("Show page title text?", 'ct_theme') ?></p>

            <p>
                <label for="show_breadcrumbs"><?php _e('Show breadcrumbs', 'ct_theme') ?>: </label>
                <select id="show_breadcrumbs" name="show_breadcrumbs">
                    <option
                        value="global" <?php echo selected('global', $bread) ?>><?php _e("use global settings", 'ct_theme') ?></option>
                    <option
                        value="yes" <?php echo selected('yes', $bread) ?>><?php _e("show breadcrumbs", 'ct_theme') ?></option>
                    <option
                        value="no" <?php echo selected('no', $bread) ?>><?php _e("hide breadcrumbs", 'ct_theme') ?></option>
                </select>
            </p>
            <p class="howto"><?php _e("Show breadcrumbs?", 'ct_theme') ?></p>

        <?php
        }


        public function pageHeaderMeta()
        {

            global $post;
            $custom = get_post_custom($post->ID);

            $pages_sidebar_show  = isset($custom["pages_sidebar_show"][0]) ? $custom["pages_sidebar_show"][0] : "";
            $pages_sidebar_block = isset($custom['pages_sidebar_block'][0]) ? $custom['pages_sidebar_block'][0] : '';
            $pages_sidebar_bg_img = isset($custom['pages_sidebar_bg_img'][0]) ? $custom['pages_sidebar_bg_img'][0] : '';
            $pages_sidebar_bg_repeat= isset($custom['pages_sidebar_bg_repeat'][0]) ? $custom['pages_sidebar_bg_repeat'][0] : '';
            $pages_sidebar_bg_animated= isset($custom['pages_sidebar_bg_animated'][0]) ? $custom['pages_sidebar_bg_animated'][0] : '';



            $attributes['limit'] = 1000;
            $recentposts = get_posts(array('post_type' => 'ct_sidebar_block', 'posts_per_page'=>-1), $attributes);
            if (is_array($recentposts) && !empty($recentposts)):?>
                <p>
                    <label for="pages_sidebar_block"><?php _e('select sidebar block', 'ct_theme') ?>: </label>
                    <select id="pages_sidebar_block" name="pages_sidebar_block">
                        <option value="" <?php echo selected('none', $pages_sidebar_block) ?>>None</option>
                        <option value="global" <?php echo selected('global', $pages_sidebar_block) ?>>Global</option>
                        <?php
                        foreach ($recentposts as $p):;?>
                            <option
                                value="<?php echo esc_html($p->ID) ?>" <?php echo selected($p->ID, $pages_sidebar_block) ?>><?php echo esc_html($p->post_title) ?></option>
                            <?php
                        endforeach;
                        ?>
                    </select>
                </p>
            <?php endif?>

            <p>
                <label for="pages_sidebar_show"><?php _e('Show sidebar?', 'ct_theme') ?>: </label>
                <select id="pages_sidebar_show" name="pages_sidebar_show">
                    <option
                        value="show" <?php echo selected('show', $pages_sidebar_show) ?>><?php _e("show", 'ct_theme') ?></option>
                    <option
                        value="hide" <?php echo selected('hide', $pages_sidebar_show) ?>><?php _e("hide", 'ct_theme') ?></option>
                </select>
            </p>

            <p>
                <label for="pages_sidebar_bg_img"><?php _e('header image URL', 'ct_theme') ?>: </label>
                <input id="pages_sidebar_bg_img" class="regular-text" name="pages_sidebar_bg_img"
                       value="<?php echo esc_attr($pages_sidebar_bg_img); ?>"/>
            </p>

            <p>
                <label for="pages_sidebar_bg_repeat"><?php _e('Sidebar background style', 'ct_theme') ?>: </label>
                <select id="pages_sidebar_bg_repeat" name="pages_sidebar_bg_repeat">
                    <option
                        value="global" <?php echo selected('global', $pages_sidebar_bg_repeat) ?>><?php _e("use global settings", 'ct_theme') ?></option>
                    <option
                        value="no-repeat" <?php echo selected('no-repeat', $pages_sidebar_bg_repeat) ?>><?php _e("no repeat", 'ct_theme') ?></option>
                    <option
                        value="ct_none" <?php echo selected('ct_none', $pages_sidebar_bg_repeat) ?>><?php _e("repeat", 'ct_theme') ?></option>
                </select>
            </p>

            <p>
                <label for="pages_sidebar_bg_animated"><?php _e('Sidebar background animated', 'ct_theme') ?>: </label>
                <select id="pages_sidebar_bg_animated" name="pages_sidebar_bg_animated">
                    <option
                        value="global" <?php echo selected('global', $pages_sidebar_bg_animated) ?>><?php _e("use global settings", 'ct_theme') ?></option>
                    <option
                        value="ct-u-hideAnimateBg" <?php echo selected('ct-u-hideAnimateBg', $pages_sidebar_bg_animated) ?>><?php _e("no", 'ct_theme') ?></option>
                    <option
                        value="ct_none" <?php echo selected('ct_none', $pages_sidebar_bg_animated) ?>><?php _e("yes", 'ct_theme') ?></option>
                </select>
            </p>

            <?php
        }

        public function pageGalleryMeta()
        {

            global $post;
            $custom = get_post_custom($post->ID);

            $pages_gallery_id = isset($custom['pages_gallery_id'][0]) ? $custom['pages_gallery_id'][0] : '';
            /*$pages_sidebar_bg_img = isset($custom['pages_sidebar_bg_img'][0]) ? $custom['pages_sidebar_bg_img'][0] : '';
            $pages_sidebar_bg_repeat= isset($custom['pages_sidebar_bg_repeat'][0]) ? $custom['pages_sidebar_bg_repeat'][0] : '';*/


            $attributes['limit'] = 9999;
            $recentposts = get_posts(array('post_type' => 'ct_gallery'), $attributes);
            if (is_array($recentposts) && !empty($recentposts)):?>
                <p>
                    <label for="pages_sidebar_block"><?php _e('select gallery name', 'ct_theme') ?>: </label>
                    <select id="pages_sidebar_block" name="pages_sidebar_block">
                        <option value="" <?php echo selected('pages_gallery_id', $pages_gallery_id) ?>>None</option>
                        <?php
                        foreach ($recentposts as $p):;?>
                            <option
                                value="<?php echo esc_html($p->ID) ?>" <?php echo selected($p->ID, $pages_gallery_id) ?>><?php echo esc_html($p->post_title) ?></option>
                            <?php
                        endforeach;
                        ?>
                    </select>
                </p>
            <?php endif?>

            <?php
        }

        public function saveDetails()
        {
            parent::saveDetails();
            global $post;
            $fields = array(
                'pages_sidebar_show',
                'pages_sidebar_bg_animated',
                'pages_sidebar_block',
                'pages_sidebar_bg_img',
                'pages_sidebar_bg_repeat',
                'pages_gallery_id'
            );
            foreach ($fields as $field) {
                if (isset($_POST[$field])) {
                    update_post_meta($post->ID, $field, $_POST[$field]);
                }
            }
        }
    }

    new ctPageType();

}