(function ($) {
    var variationGlobal;
    "use strict";

    var addButtonPressed = false;
    var removeButtonPressed = false;

    function onAddButtonClicked ( event ) {
        if ( addButtonPressed ) return;

        if($('#ct-waitlist-out-of-stock-type').val() == 'variation'){
            email = $('#ct-waitlist-email').val();
        }else{
            email = $(this).parent().parent().find('#ct-waitlist-email').val();
        }
        if (validateForm(email) == false ) {
            $(this).parent().blur();
            if($('#ct-waitlist-out-of-stock-type').val() != 'variation'){
                $(this).parent().parent().find('#ct-waitlist-email').focus();
            } else {
                $('.ct-waitlist-content').find('#ct-waitlist-email').focus();
            }
            $('.ct-waitlist-content .error').show();
        }
        else {
            $('.ct-waitlist-content .error').hide();
            var productId, email, outOfStockType, outOfStockParent, postponeEmail;
            outOfStockType = $('#ct-waitlist-out-of-stock-type').val();
            outOfStockParent = $('#ct-waitlist-out-of-stock-parent-id').length ? $('#ct-waitlist-out-of-stock-parent-id').val() : false;
            postponeEmail = $('#ct-waitlist-use-postpone').val();

            if ($(this).parent().parents('tr').length) {
                productId = $(this).parent().parents('tr').find('#ct-waitlist-productid').val();
                email = $.trim($(this).parent().parents('tr').find('#ct-waitlist-email').val());
            }
            else {
                productId = $('#ct-waitlist-productid').val();
                email = $.trim($('#ct-waitlist-email').val());
            }
            $.ajax({
                url: ctAjax.adminAjaxUrl,
                dataType: 'json',
                type: 'POST',
                context: '.ct-waitlist-add-button',
                data: {
                    action: 'ctWaitlist_add_to_database',
                    prodid: productId,
                    email: email,
                    parentid: outOfStockParent,
                    is_grouped: outOfStockType == "grouped" ? 1 : 0,
                    is_variation: outOfStockType == "variation" ? 1 : 0,
                    variationid: outOfStockType == "variation" ? parseInt($('input[name="variation_id"]').val()) : 0,
                    postponeEmail: postponeEmail
                },
                success: function () {
                    if (outOfStockType == "variation") {
                        $('#subbed').append('<input type="hidden" value="' + parseInt($('input[name="variation_id"]').val()) + '"/>');
                    }
                },
                error: function () {
                }
            });
            var subscriptionSuccess = $.trim($('#ct-waitlist-subscriptionsuccess').val());
            subscriptionSuccess = '<span class="ct-waitlist-subscriptionsuccess-message">' + subscriptionSuccess + '</span>';


            var hidden = $(this).closest('.ct-waitlist-content').find('.ct-waitlist-content-hidden').html();
            if ( hidden ) {
                $(this).closest('.ct-waitlist-content').find('.ct-waitlist-content-hidden').html( $(this).parent().parent().html() );
                $(this).parent().parent().html( hidden );
            } else {
                // not logged in
                $(this).parent().parent().find('.ct-waitlist-add-button').hide();
                $(this).parent().parent().find('.ct-waitlist-input-email').hide();

                var oldMessage = $('.ct-waitlist-subscribers-count').html();
                if ( oldMessage ) {
                    var count = parseInt(oldMessage.replace(/\D+/g, ''));
                    var newMessage = oldMessage.replace(count, count + 1);
                    $('.ct-waitlist-subscribers-count').html(newMessage);
                }

                $(this).parent().prepend(subscriptionSuccess);
            }
            addButtonPressed = true;
            setTimeout( function() {
                addButtonPressed = false;
                removeButtonPressed = false;
            }, 500 );
        }
    };

    function onRemoveButtonClicked() {
        if ( removeButtonPressed ) return;

        var entryId, removedNotification, mail;
        removedNotification = $.trim($('#ct-waitlist-removed-message').val());
        entryId = variationGlobal ? variationGlobal : parseInt($(this).closest('div').find('input[name="ct-waitlist-to-remove-id"]').val());
        mail = variationGlobal ? $.trim($('#ct-waitlist-email').val()) : ''; // send email only for variations. see php logic
        $.ajax({
            url: ctAjax.adminAjaxUrl,
            dataType: 'json',
            type: 'POST',
            data: {
                action: 'ctWaitlist_remove_subscription',
                id: entryId,
                email: mail,
            },
            success: function () {},
            error: function () {}
        });

        // switch content with hidden
        var hidden = $(this).closest('.ct-waitlist-content').find('.ct-waitlist-content-hidden').html();
        $(this).closest('.ct-waitlist-content').find('.ct-waitlist-content-hidden').html( $(this).parent().parent().html() );
        $(this).parent().parent().html( hidden );

        removeButtonPressed = true;
        setTimeout( function() {
            addButtonPressed = false;
            removeButtonPressed = false;
        }, 500 );

        // $(this).parent().parent().html( removedNotification );
        // $(this).parent().remove();
    }

    $(function () {


        $('.ct-waitlist-content').on('click', '.ct-waitlist-add-button', onAddButtonClicked );

        $('.ct-waitlist-content').on('click', '.ct-waitlist-remove-button', onRemoveButtonClicked);

        $('.ct-waitlist-remove-my-account-button').on('click', function () {
            var entryId;
            entryId = $(this).parent().find('input').val();

            $.ajax({
                url: ctAjax.adminAjaxUrl,
                dataType: 'json',
                type: 'POST',
                data: {
                    action: 'ctWaitlist_remove_subscription',
                    id: entryId
                },
                success: function () {
                },
                error: function () {
                }
            });
            $(this).parent().html($('#ct-waitlist-removed-message').val());

        });

        if ($('.variations_form').length) {
            var productVariations;
            productVariations = $('.variations_form').data('product_variations');
            $('input[name="variation_id"]').on('change', function () {
                var counter, inStock, selectedVariation;
                selectedVariation = parseInt($(this).val()) > 0 ? parseInt($(this).val()) : false;
                if (selectedVariation) {
                    for (counter = 0; counter < productVariations.length; counter++) {
                        if (parseInt(productVariations[counter].variation_id) === selectedVariation) {
                            inStock = productVariations[counter].is_in_stock;
                            if (inStock !== true) {
                                updateDiv(false);
                            }
                        }
                    }
                } else {
                    updateDiv(false);
                }
            });
        }

        jQuery('.ct-waitlist-content-hidden').hide();
    });


    function updateDiv(par) {
        "use strict";

        var productId, isLoggedIn, waitlistDiv, buttonText, unsubscribeText, varAlreadySubscribed, notifymessage, unsubPage, placeholder, style, hiddenDiv, countMessage, countNumber, successText;
        productId = $('#ct-waitlist-productid').val();
        isLoggedIn = $('#ct-waitlist-user-logged-in').val();
        unsubscribeText = $.trim($('#ct-waitlist-unsubscribe-button').val());
        varAlreadySubscribed = $.trim($('#ct-waitlist-variable-subscribed').val());
        successText = $.trim($('#ct-waitlist-subscriptionsuccess').val());
        notifymessage = $.trim($('#ct-waitlist-notify-message').val());
        buttonText = $.trim($('#ct-waitlist-subscribe-button').val());
        unsubPage = parseInt($('#ct-waitlist-unsubscribe-page').val());
        placeholder = $.trim($('#ct-waitlist-placeholder-text').val());
        style = parseInt($('#ct-waitlist-style').val());
        countMessage = ($('#ct-waitlist-count-message').val());
        countNumber = parseInt($('#ct-waitlist-count-number').val());

        if (par) {
            $('.ct-waitlist-content.variations').html('');
        }
        else {
            if (isLoggedIn == 1) {
                if (style !=1) {
                    waitlistDiv = '<div>';
                    waitlistDiv += '<p class="ct-waitlist-notification">' + notifymessage + '</p>';
                    waitlistDiv += '<div class="ct-waitlist-button-container">';
                    waitlistDiv += '<button type="button" class="single_add_to_cart_button button btn btn-primary ct-waitlist-add-button">' + buttonText + '</button>';
                } else {
                    waitlistDiv = '<div>';
                    waitlistDiv += '<div class="ct-waitlist-button-container">';
                    waitlistDiv += '<button type="button" class="single_add_to_cart_button button btn btn-primary ct-waitlist-add-button">' + buttonText + '</button>';
                }
                waitlistDiv += '<p class="ct-waitlist-subscribers-count">' + countMessage + '</p>';
                waitlistDiv += '</div>'; // btn container

                hiddenDiv  = '<div class="ct-waitlist-content-hidden" style="display: none">';
                hiddenDiv += '<p class="ct-waitlist-notification">' + successText + '</p>';
                hiddenDiv += '<div class="ct-waitlist-button-container">';
                if (unsubPage === 2 || unsubPage === 3) {
                    hiddenDiv += '<button type="button" class="single_add_to_cart_button button btn btn-primary ct-waitlist-remove-variation">' + unsubscribeText + '</button>';
                }
                hiddenDiv += '<p class="ct-waitlist-subscribers-count">' + countMessage.replace( countNumber, countNumber + 1 ) + '</p>';
                hiddenDiv += '</div>'; // btn container
                hiddenDiv += '</div>';
                waitlistDiv += '</div>';
                waitlistDiv += hiddenDiv;

                $('#subbed').children().each(function () {
                    if (parseInt($('input[name="variation_id"]').val()) == this.value) {
                        variationGlobal = parseInt(this.value);
                        if(style!=1)
                        {
                            waitlistDiv = '<div><p class="ct-waitlist-notification">' + varAlreadySubscribed + '</p>';
                            waitlistDiv += '<div class="ct-waitlist-button-container">';

                            if (unsubPage === 2 || unsubPage === 3) {
                                waitlistDiv += '<button type="button" class="single_add_to_cart_button button btn btn-primary ct-waitlist-remove-variation">' + unsubscribeText + '</button>';
                            }
                        } else {
                            waitlistDiv = '<p class="ct-waitlist-notification">' + varAlreadySubscribed + '</p>';
                            if (unsubPage === 2 || unsubPage === 3) {
                                waitlistDiv += '<button type="button" class="single_add_to_cart_button button btn btn-primary ct-waitlist-remove-variation">' + unsubscribeText + '</button>';
                            }
                        }
                        waitlistDiv += '<p class="ct-waitlist-subscribers-count">' + countMessage + '</p>';
                        waitlistDiv += '</div>';
                        waitlistDiv += '</div>';

                        hiddenDiv  = '<div class="ct-waitlist-content-hidden" style="display: none">';
                        if (style !=1) {
                            hiddenDiv += '<p class="ct-waitlist-notification">' + notifymessage + '</p>';
                        }
                        hiddenDiv += '<div class="ct-waitlist-button-container">';
                        hiddenDiv += '<button type="button" class="single_add_to_cart_button button btn btn-primary ct-waitlist-add-button">' + buttonText + '</button>';
                        hiddenDiv += '<p class="ct-waitlist-subscribers-count">' + countMessage.replace( countNumber, countNumber - 1 ) + '</p>';
                        hiddenDiv += '</div>';
                        hiddenDiv += '</div>';
                        waitlistDiv += hiddenDiv;

                        return false;
                    }
                });
            }
            else {
                if (style != 1) {
                    waitlistDiv = '<p class="ct-waitlist-notification">' + notifymessage + '</p>';
                    waitlistDiv += '<p><input type="text" class="ct-waitlist-input-email form-control" id="ct-waitlist-email" placeholder="'+ placeholder + '" /></p>';
                    waitlistDiv += '<button class="single_add_to_cart_button button btn btn-primary ct-waitlist-add-button" type="button">' + buttonText + '</button>';
                    waitlistDiv += '<input type="hidden" id="ct-waitlist-productid" value="' + productId + '" />';
                } else {
                    waitlistDiv = '<input type="text" style="width:70%; display:inline; float:left;" class="ct-waitlist-input-email form-control" placeholder="'+placeholder+'" id="ct-waitlist-email"/>';
                    waitlistDiv += '<button type="button" style="width:30%; display:inline " class="single_add_to_cart_button button btn btn-primary ct-waitlist-add-button">' + buttonText + '</button>';

                }
            }
            setTimeout(function () {
                $('.ct-waitlist-content.variations').html( waitlistDiv );
                $('.ct-waitlist-content.variations').on('click', '.ct-waitlist-add-button', onAddButtonClicked );
                $('.ct-waitlist-content.variations').on('click', '.ct-waitlist-remove-variation', onRemoveButtonClicked );

            }, 200);
        }
    }

    function validateForm(email) {
        var x = email;
        var atpos = x.indexOf("@");
        var dotpos = x.lastIndexOf(".");
        if (atpos < 1 || dotpos < atpos + 2 || dotpos + 2 >= x.length) {
            return false;
        }
    }

}(jQuery));
